#!/usr/bin/php
<?php

use Cache\FileCache;
use Logger\Log;
use Wildix\Core\Container;
use Wildix\PersonalSettings\TrustedIps\TrustedIpsService;

require_once('/var/www/init.php');

/** @var FileCache $cache */
$cache = Container::get(FileCache::class);

$params = getopt('', ['ip:']);

$key = sprintf(TrustedIpsService::CACHE_TRUSTED_IP, $params['ip']);

Container::get(Log::class)->info(__LINE__, 'ADDED NEW IP ' . $key);
$cache->set($key, '', 3600, TrustedIpsService::CACHE_GROUP);

exit();
