<?php
require_once '/var/www/init.php';

use Console\DataStorageSyncBackups;
use Logger\Log;
use Services\Helpers;
use Wildix\Core\Container;

$params = [];
$enable = env('SERVICE_DATA_STORAGE_ENABLE', false);

if (is_array(getopt('f::')) && getopt('f::')['f']) {
    $params['file'] = getopt('f::')['f'];
}

if ($enable) {
    Helpers::addTask(DataStorageSyncBackups::NAME, $params);
}
$message = sprintf('Queue manager: new job::%s, enable::%s', DataStorageSyncBackups::NAME, $enable ? '1' : '0');
Container::get(Log::class)->info(__LINE__, $message);
dump($message);
