WMS.Phonebooks = function(data) {

    this.syncGoogleAuthUrlAvailable = false;
    this.syncGoogleAuthUrl = '';

    this.office365AuthUrlAvailable = false;
    this.office365AuthUrl = '';

    this.infusionsoftAuthUrlAvailable = false;
    this.infusionsoftAuthUrl = '';

    initialize = (data) => {
        this.varsPhp = data;
    };

    this.initForm = function (params) {
        this.pSyncSettingsAndMap;
        this.pSyncFields = this.varsPhp.pSyncFields;
        this.pSyncUpdater;
        this.pSyncCurrBackend;

        this.pSyncSettingsAndMap = params;

        this.pSyncSetFrom();

        Event.observe($('p_s_backend_backend'), 'change', (event) => {
            this.pSyncChangeBackend(Event.element(event).value);
        });

        Event.observe($('p_s_backend_csv_import_type'), 'change', (event) => {
            this.pSyncChangeCsvImportType(Event.element(event).value);
        });

        Event.observe($('ps_recurrent_on'), 'click',  (event) => {
            this.pSyncToggleRecurrentJob(Event.element(event), 'ps_recurrent_interval', 'ps_recurrent_email');
        });

        Event.observe($('p_s_backend_office365_login'), 'click', _onClickOffice365Login);
        Event.observe($('p_s_backend_office365_logout'), 'click', _onClickOffice365Logout);
        Event.observe($('p_s_backend_office365_access_to_directory'), 'click',  () => {
            getOffice365AuthUrl('phonebooks', (response) => {
                this.office365AuthUrlAvailable = true;
                this.office365AuthUrl          = response.url;
            }, () => {
                ap_showWaitMessage('waitDiv', 0);
                setError('error', 'Cannot fetch Office365 Auth url');
            }, {
                directory: ($('p_s_backend_office365_access_to_directory').checked ? 'yes' : 'no'),
                nocache: true
            });
        });

        Event.observe($('p_s_backend_google_login'), 'click', _onClickGoogleLogin);
        Event.observe($('p_s_backend_google_logout'), 'click', _onClickGoogleLogout);

        Event.observe($('p_s_backend_infusionsoft_login'), 'click', _onClickInfusionsoftLogin);
        Event.observe($('p_s_backend_infusionsoft_logout'), 'click', _onClickInfusionsoftLogout);

        Event.observe($('p_s_backend_exchange_login'), 'click', _onClickExchangeLogin);
        Event.observe($('p_s_backend_exchange_logout'), 'click', _onClickExchangeLogout);

        jQuery('#phonebooks_sync_backend_settings_form .p_s_backend_office365 .phonebooksList').on('change', 'input[type="checkbox"]', _onSelectOffice365Phonebook);
        jQuery('#phonebooks_sync_backend_settings_form .p_s_backend_google .phonebooksList').on('change', 'input[type="checkbox"]', _onSelectGooglePhonebook);
        jQuery('#phonebooks_sync_backend_settings_form .p_s_backend_exchange .phonebooksList').on('change', 'input[type="checkbox"]', _onSelectExchangePhonebook);

        $$('.pSyncToggleMapAttr').each((e) => {
            Event.observe(e, 'click', (event) => {
                this.pSyncToggleMapAttr(Event.element(event), Event.element(event).id.slice(0, -3));
            });
        });
    };

    _onSelectOffice365Phonebook = (event) => {
        var phonebooks = [];
        jQuery('#phonebooks_sync_backend_settings_form .p_s_backend_office365 .phonebooksList input[type="checkbox"]:checked').each( (index, el) => {
            phonebooks.push(jQuery(el).val());
        });
        jQuery('#p_s_backend_office365_phonebooks').val(phonebooks.join(','));
    };

    _onClickOffice365Login = (event) => {
        window.callbackOffice365FunctionContacts = _onOffice365LoginCallback;

        if (this.office365AuthUrlAvailable) {
            window.open(
                this.office365AuthUrl,
                "Office365 sing on",
                "location=0,status=0,scrollbars=0,width=800,height=500"
            );
        } else {
            setError('error', 'Office365 Auth url unavailable');
        }
    };

    _onClickOffice365Logout = (event) => {
        $('p_s_backend_office365_mail').value                = '';
        $('p_s_backend_office365_mail_text').innerHTML       = '';
        $('p_s_backend_office365_received_token_time').value = '';
        $('p_s_backend_office365_access_token').value        = '';
        $('p_s_backend_office365_token_type').value          = '';
        $('p_s_backend_office365_expires_in').value          = '';
        $('p_s_backend_office365_id_token').value            = '';
        $('p_s_backend_office365_id_token_expires_in').value = '';
        $('p_s_backend_office365_refresh_token').value       = '';
        $('p_s_backend_office365_phonebooks').value          = '';
        $('p_s_backend_office365_logout').hide();
        $('p_s_backend_office365_login').show();
        $('p_s_backend_office365_access_to_directory').disabled = false;

        jQuery('#phonebooks_sync_backend_settings_form .p_s_backend_office365 .phonebooksList').html('');

        this.pSyncDoSave();
    };

    _onOffice365LoginCallback = (result) => {
        if (!result) {
            // error
            return;
        }
        if (result.error && result.error != '' && result.error_description) {
            setError('error', result.error_description);
        } else if (result.token && result.userInfo) {
            _loadOffice365Phonebooks(result);
        }
    };

    _loadOffice365Phonebooks = (data) => {
        ap_showWaitMessage('waitDiv', 1);
        getOffice365AuthUrl('phonebooks', (response) => {
            this.office365AuthUrlAvailable = true;
            this.office365AuthUrl          = response.url;
            new Ajax.Request('aclpbx/index.php', {
                method: 'post',
                parameters: $H({
                    action: 'get_office365_phonebooks',
                    token: $H(data.token).toJSON()
                }).toQueryString(),
                onComplete: (transport) =>  {
                    ap_showWaitMessage('waitDiv', 0);
                    if ("responseJSON" in transport && "phonebooks" in transport.responseJSON) {
                        var response = transport.responseJSON;

                        if (data.userInfo) {
                            $('p_s_backend_office365_mail').value          = data.userInfo.preferred_username;
                            $('p_s_backend_office365_mail_text').innerHTML = data.userInfo.preferred_username;
                        }

                        $('p_s_backend_office365_received_token_time').value = response.token.received_token_time;
                        $('p_s_backend_office365_access_token').value        = response.token.access_token;
                        $('p_s_backend_office365_token_type').value          = response.token.token_type;
                        $('p_s_backend_office365_expires_in').value          = response.token.expires_in;
                        $('p_s_backend_office365_id_token').value            = response.token.id_token;
                        $('p_s_backend_office365_id_token_expires_in').value = response.token.id_token_expires_in;
                        $('p_s_backend_office365_refresh_token').value       = response.token.refresh_token;
                        $('p_s_backend_office365_logout').show();
                        $('p_s_backend_office365_login').hide();
                        $('p_s_backend_office365_access_to_directory').disabled = true;

                        if (response.phonebooks.length > 0) {
                            var html            = '';
                            var n               = 0;
                            var directoryAccess = $('p_s_backend_office365_access_to_directory').checked ? true : false;
                            for (var i = 0; i < response.phonebooks.length; i++) {
                                var phonebook = response.phonebooks[i];
                                if (phonebook.id == 'global' && !directoryAccess) {
                                    continue;
                                }
                                html += '<div><input type="checkbox" value="' + phonebook.id + '" id="p_s_backend_office365_phonebook_' + n + '"><label for="p_s_backend_office365_phonebook_' + n + '">' + phonebook.name + '</label></div>'
                                n++;
                            }
                            jQuery('#phonebooks_sync_backend_settings_form .p_s_backend_office365 .phonebooksList').html(html);
                            var phonebooks = jQuery('#p_s_backend_office365_phonebooks').val().split(',');
                            for (var i = 0; i < phonebooks.length; i++) {
                                jQuery('#phonebooks_sync_backend_settings_form .p_s_backend_office365 .phonebooksList input[value="' + phonebooks[i] + '"]').attr('checked', 'checked');
                            }
                        }
                    } else if ("error" in transport.responseJSON && "message" in transport.responseJSON.error) {
                        setError('error', transport.responseJSON.error.message);
                    }
                }
            });
        }, () => {
            ap_showWaitMessage('waitDiv', 0);
            setError('error', 'Cannot fetch Office365 Auth url');
        }, {
            directory: ($('p_s_backend_office365_access_to_directory').checked ? 'yes' : 'no'),
            nocache: true
        });
    };

    _onSelectGooglePhonebook = (event) => {
        var phonebooks = [];
        jQuery('#phonebooks_sync_backend_settings_form .p_s_backend_google .phonebooksList input[type="checkbox"]:checked').each( (index, el) => {
            phonebooks.push(jQuery(el).val());
        });
        jQuery('#p_s_backend_google_phonebooks').val(phonebooks.join(','));
    };

    _onClickGoogleLogin = (event) => {
        var windowOpen = (syncGoogleAuthUrl) => {
            window.open(
                syncGoogleAuthUrl,
                "Google sing on",
                "location=0,status=0,scrollbars=0,width=800,height=500"
            );
        };

        window.callbackFunctionPhonebooks = _onGoogleLoginCallback;

        if (this.syncGoogleAuthUrlAvailable) {
            windowOpen(this.syncGoogleAuthUrl);
        } else {
            setError('error', 'Google Auth url unavailable');
        }
    };

    _onClickGoogleLogout = (event) => {
        $('p_s_backend_google_mail').value                = '';
        $('p_s_backend_google_mail_text').innerHTML       = '';
        $('p_s_backend_google_received_token_time').value = '';
        $('p_s_backend_google_access_token').value        = '';
        $('p_s_backend_google_token_type').value          = '';
        $('p_s_backend_google_expires_in').value          = '';
        $('p_s_backend_google_refresh_token').value       = '';
        $('p_s_backend_google_phonebooks').value          = '';
        $('p_s_backend_google_logout').hide();
        $('p_s_backend_google_login').show();

        jQuery('#phonebooks_sync_backend_settings_form .p_s_backend_google .phonebooksList').html('');

        this.pSyncDoSave();
    };

    _onGoogleLoginCallback = (result) => {
        if (!result) {
            // error
            return;
        }
        if (result.error && result.error != '' && result.error_description) {
            setError('error', result.error_description);
        } else if (result.token && result.userInfo) {
            _loadGooglePhonebooks(result);
        }
    };

    _loadGooglePhonebooks = (data) => {
        ap_showWaitMessage('waitDiv', 1);
        getGoogleAuthUrl('phonebooks', (response) => {
            this.syncGoogleAuthUrlAvailable = true;
            this.syncGoogleAuthUrl          = response.url;

            new Ajax.Request('aclpbx/index.php', {
                method: 'post',
                parameters: $H({
                    action: 'get_google_phonebooks',
                    token: $H(data.token).toJSON()
                }).toQueryString(),
                onComplete: function (transport) {
                    ap_showWaitMessage('waitDiv', 0);
                    if ("responseJSON" in transport && "phonebooks" in transport.responseJSON) {
                        var response = transport.responseJSON;

                        if (data.userInfo) {
                            $('p_s_backend_google_mail').value          = data.userInfo.email;
                            $('p_s_backend_google_mail_text').innerHTML = data.userInfo.email;
                        }

                        $('p_s_backend_google_received_token_time').value = response.token.received_token_time;
                        $('p_s_backend_google_access_token').value        = response.token.access_token;
                        $('p_s_backend_google_token_type').value          = response.token.token_type;
                        $('p_s_backend_google_expires_in').value          = response.token.expires_in;
                        $('p_s_backend_google_refresh_token').value       = response.token.refresh_token;
                        $('p_s_backend_google_logout').show();
                        $('p_s_backend_google_login').hide();

                        if (response.phonebooks.length > 0) {
                            var html = '';
                            var n    = 0;

                            for (var i = 0; i < response.phonebooks.length; i++) {
                                var phonebook = response.phonebooks[i];
                                if (phonebook.memberCount === 0) {
                                    continue;
                                }

                                 html += '<div><input type="checkbox" value="' + phonebook.id + '" id="p_s_backend_google_phonebook_' + n + '"><label for="p_s_backend_google_phonebook_' + n + '">' + phonebook.name.replace('System Group: ', '') + ' (' + phonebook.memberCount + ')</label></div>';
                                n++;
                            }
                            jQuery('#phonebooks_sync_backend_settings_form .p_s_backend_google .phonebooksList').html(html);
                            var phonebooks = jQuery('#p_s_backend_google_phonebooks').val().split(',');
                            for (var i = 0; i < phonebooks.length; i++) {
                                jQuery('#phonebooks_sync_backend_settings_form .p_s_backend_google .phonebooksList input[value="' + phonebooks[i] + '"]').attr('checked', 'checked');
                            }
                        }
                    } else if ("error" in transport.responseJSON && "message" in transport.responseJSON.error) {
                        setError('error', transport.responseJSON.error.message);
                    }
                }.bind(this)
            });
        }, (response) => {
            ap_showWaitMessage('waitDiv', 0);
            setError('error', 'Cannot fetch Google Auth url');
        });
    };

    _onClickInfusionsoftLogin = () => {
        window.callbackInfusionsoftFunctionContacts = _onInfusionsoftLoginCallback;

        if (this.infusionsoftAuthUrlAvailable) {
            window.open(
                this.infusionsoftAuthUrl,
                "Infusionsoft sing on",
                "location=0,status=0,scrollbars=0,width=800,height=500"
            );
        } else {
            setError('error', 'Infusionsoft Auth url unavailable');
        }
    };

    _onClickInfusionsoftLogout = () => {
        $('p_s_backend_infusionsoft_mail').value                = '';
        $('p_s_backend_infusionsoft_mail_text').innerHTML       = '';
        $('p_s_backend_infusionsoft_app').value                 = '';
        $('p_s_backend_infusionsoft_app_text').innerHTML        = '';
        $('p_s_backend_infusionsoft_received_token_time').value = '';
        $('p_s_backend_infusionsoft_access_token').value        = '';
        $('p_s_backend_infusionsoft_token_type').value          = '';
        $('p_s_backend_infusionsoft_expires_in').value          = '';
        $('p_s_backend_infusionsoft_refresh_token').value       = '';

        $('p_s_backend_infusionsoft_logout').hide();
        $('p_s_backend_infusionsoft_login').show();

        this.pSyncDoSave();
    },

    _onInfusionsoftLoginCallback = (result) => {
        if (!result) {
            return;
        }
        if (result.error) {
            setError('error', result.error);
        } else if (result.token && result.userInfo) {
            var token = result.token;
            for (var key in token) {
                this.pSyncSettingsAndMap.infusionsoft_settings[key] = token[key];
            }
            this.pSyncSettingsAndMap.infusionsoft_settings['mail'] = result.userInfo.email;
            this.pSyncSettingsAndMap.infusionsoft_settings['app'] = result.userInfo.app;
            _setInfusionsoftAuthCredentials(result);
        }
    };

    _setInfusionsoftAuthCredentials = (data) => {
        ap_showWaitMessage('waitDiv', 1);
        getInfusionsoftAuthUrl('full', (response) => { // Infusionsoft support only full scope
            this.infusionsoftAuthUrlAvailable = true;
            this.infusionsoftAuthUrl          = response.url;

            ap_showWaitMessage('waitDiv', 0);

            if (!data || !data.token) {
                return;
            }

            var token = data.token;
            var userInfo = data.userInfo;
            var unauthorized = '';

            if (userInfo && userInfo.app) {
                var accessTokenExpired = (+token.received_token_time) + (+token.expires_in) - Date.now() / 1000 < 3 * 60 * 60;
                var recurrentJobDisabled = this.pSyncSettingsAndMap.recurrent_job.enabled === 'no';

                if (accessTokenExpired && recurrentJobDisabled) {
                    unauthorized = ' (unauthorized)';
                }

                $('p_s_backend_infusionsoft_mail').value          = userInfo.email;
                $('p_s_backend_infusionsoft_mail_text').innerHTML = userInfo.email + unauthorized;
                $('p_s_backend_infusionsoft_app').value           = userInfo.app;
                $('p_s_backend_infusionsoft_app_text').innerHTML  = userInfo.app;
            }

            if (token.access_token) {
                $('p_s_backend_infusionsoft_received_token_time').value = token.received_token_time;
                $('p_s_backend_infusionsoft_access_token').value = token.access_token;
                $('p_s_backend_infusionsoft_token_type').value = token.token_type;
                $('p_s_backend_infusionsoft_expires_in').value = token.expires_in;
                $('p_s_backend_infusionsoft_refresh_token').value = token.refresh_token;

                if (!unauthorized) {
                    $('p_s_backend_infusionsoft_logout').show();
                    $('p_s_backend_infusionsoft_login').hide();
                }
            }
        }, () => {
            ap_showWaitMessage('waitDiv', 0);
            setError('error', 'Cannot fetch Infusionsoft Auth url');
        });
    };

    _onSelectExchangePhonebook = (event) => {
        var phonebooks = [];
        jQuery('#phonebooks_sync_backend_settings_form .p_s_backend_exchange .phonebooksList input[type="checkbox"]:checked').each(function (index, el) {
            phonebooks.push(jQuery(el).val());
        });
        jQuery('#p_s_backend_exchange_phonebooks').val(phonebooks.join(','));
    };

    _onClickExchangeLogin = (event) => {
        if (!this.validateImportForm()) {
            return false;
        }
        _loadExchangePhonebooks();
    };

    _onClickExchangeLogout = (event) => {
        $('p_s_backend_exchange_host').value       = '';
        $('p_s_backend_exchange_user').value       = '';
        $('p_s_backend_exchange_password').value   = '';
        $('p_s_backend_exchange_phonebooks').value = '';

        $('p_s_backend_exchange_host').disabled     = false;
        $('p_s_backend_exchange_user').disabled     = false;
        $('p_s_backend_exchange_password').disabled = false;

        $('p_s_backend_exchange_logout').hide();
        $('p_s_backend_exchange_login').show();

        jQuery('#phonebooks_sync_backend_settings_form .p_s_backend_exchange .phonebooksList').html('');

        this.pSyncDoSave();
    },

    _loadExchangePhonebooks = function () {

        var data = {
            'host': $('p_s_backend_exchange_host').value,
            'user': $('p_s_backend_exchange_user').value,
            'password': $('p_s_backend_exchange_password').value
        };

        if (data.host == '' || data.user == '' || data.password == '') {
            return;
        }
        ap_showWaitMessage('waitDiv', 1);

        new Ajax.Request('aclpbx/index.php', {
            method: 'post',
            parameters: $H({
                action: 'get_exchange_phonebooks',
                params: $H(data).toJSON()
            }).toQueryString(),
            onComplete: (transport) => {
                ap_showWaitMessage('waitDiv', 0);
                if ("responseJSON" in transport && "phonebooks" in transport.responseJSON) {
                    var response = transport.responseJSON;

                    $('p_s_backend_exchange_host').disabled     = true;
                    $('p_s_backend_exchange_user').disabled     = true;
                    $('p_s_backend_exchange_password').disabled = true;

                    $('p_s_backend_exchange_logout').show();
                    $('p_s_backend_exchange_login').hide();

                    if (response.phonebooks.length > 0) {
                        var html = '';
                        var n    = 0;

                        for (var i = 0; i < response.phonebooks.length; i++) {
                            var phonebook = response.phonebooks[i];
                            html += '<div><input type="checkbox" value="' + phonebook.FolderId + '" id="p_s_backend_exchange_phonebook_' + n + '"><label for="p_s_backend_exchange_phonebook_' + n + '">' + phonebook.Patch + '</label></div>'
                            n++;
                        }
                        jQuery('#phonebooks_sync_backend_settings_form .p_s_backend_exchange .phonebooksList').html(html);
                        var phonebooks = jQuery('#p_s_backend_exchange_phonebooks').val().split(',');
                        for (var i = 0; i < phonebooks.length; i++) {
                            jQuery('#phonebooks_sync_backend_settings_form .p_s_backend_exchange .phonebooksList input[value="' + phonebooks[i] + '"]').attr('checked', 'checked');
                        }
                    }
                } else if ("error" in transport.responseJSON && "message" in transport.responseJSON.error) {
                    setError('error', transport.responseJSON.error.message);
                }
            }
        });

    },

    this.pSyncSetFrom = function () {
        var oBackend = $('p_s_backend_backend');
        $H({
            'ldap': 'LDAP',
            'activeD': 'Active Directory',
            'domino': 'Lotus Domino',
            'mysql': 'MySQL',
            'mssql': 'MSSQL',
            'hanaDb': 'Hana DB',
            'office365': 'Office365',
            'google': 'Google',
            'infusionsoft': 'Infusionsoft',
            'exchange': 'ExchangeServer',
            'csv': 'CSV'
        }).each(function (val) {
            oBackend.options[oBackend.options.length] = new Option(val.value, val.key);
        });

        oBackend = $('ps_recurrent_interval');
        $H({'1': '1', '2': '2', '6': '6', '12': '12', '24': '24'}).each(function (val) {
            oBackend.options[oBackend.options.length] = new Option(val.value, val.key);
        });

        this.pSyncCurrBackend          = this.pSyncSettingsAndMap['global']['backend'];
        $('p_s_backend_backend').value = this.pSyncCurrBackend;

        $('p_s_global_remove_users').checked = false;
        $('p_s_global_erase_values').checked = false;
        if (this.pSyncSettingsAndMap['global']['remove_users'] == 'yes') {
            $('p_s_global_remove_users').checked = true;
        }
        if (this.pSyncSettingsAndMap['global']['erase_values'] == 'yes') {
            $('p_s_global_erase_values').checked = true;
        }

        var t_filter = '(&(objectCategory=person)(|(objectClass=user)(objectClass=contact))(!(userAccountControl:1.2.840.113556.1.4.803:=2)))';

        if (typeof this.pSyncSettingsAndMap['ldap_settings'] == 'undefined') {
            this.pSyncSettingsAndMap['ldap_settings']           = {};
            this.pSyncSettingsAndMap['ldap_settings'] = '';
        }
        var t_options = new Array(this.pSyncSettingsAndMap['ldap_settings']['filter']);
        if (this.pSyncSettingsAndMap['ldap_settings']['filter'] != t_filter) t_options.push(t_filter);
        oBackend = $('p_s_backend_ldap_filter');

        t_filter = '(&(objectCategory=person)(|(objectClass=user)(objectClass=contact))(!(userAccountControl:1.2.840.113556.1.4.803:=2)))';

        if (typeof this.pSyncSettingsAndMap['activeD_settings'] == 'undefined') {
            this.pSyncSettingsAndMap['activeD_settings']           = {};
            this.pSyncSettingsAndMap['activeD_settings']['filter'] = '';
        }
        var t_options = new Array(this.pSyncSettingsAndMap['activeD_settings']['filter']);
        if (this.pSyncSettingsAndMap['activeD_settings']['filter'] != t_filter) t_options.push(t_filter);
        oBackend = $('p_s_backend_activeD_filter');

        t_filter = 'SELECT ${MAP} FROM `contacts_table` WHERE `type`="customer"';

        if (typeof this.pSyncSettingsAndMap['mysql_settings'] == 'undefined') {
            this.pSyncSettingsAndMap['mysql_settings']           = {};
            this.pSyncSettingsAndMap['mysql_settings']['filter'] = '';
        }

        t_options = new Array(this.pSyncSettingsAndMap['mysql_settings']['filter']);
        if (this.pSyncSettingsAndMap['mysql_settings']['filter'] != t_filter) t_options.push(t_filter);
        oBackend = $('p_s_backend_mysql_filter');

        t_filter = 'SELECT ${MAP} FROM [contacts_table] WHERE [type]="customer"';
        t_filter = 'SELECT ${MAP} FROM [contacts_table] WHERE [type]="customer"';

        if (typeof this.pSyncSettingsAndMap['mssql_settings'] == 'undefined') {
            this.pSyncSettingsAndMap['mssql_settings']           = {};
            this.pSyncSettingsAndMap['mssql_settings']['filter'] = '';
        }
        t_options = new Array(this.pSyncSettingsAndMap['mssql_settings']['filter']);
        if (this.pSyncSettingsAndMap['mssql_settings']['filter'] != t_filter) t_options.push(t_filter);
        oBackend = $('p_s_backend_hanaDb_filter');

        t_filter = 'select ${MAP} from ${DBNAME}."OCRD"';

        if (typeof this.pSyncSettingsAndMap['hanaDb_settings'] == 'undefined') {
            this.pSyncSettingsAndMap['hanaDb_settings']           = {};
            this.pSyncSettingsAndMap['hanaDb_settings']['filter'] = '';
        }
        t_options = new Array(this.pSyncSettingsAndMap['hanaDb_settings']['filter']);
        if (this.pSyncSettingsAndMap['hanaDb_settings']['filter'] != t_filter) t_options.push(t_filter);
        oBackend = $('p_s_backend_mssql_filter');

        oBackend = $('p_s_backend_csv_import_mountpoint');
        $H(cSyncMounts).each(function (pair) {
            oBackend.options[oBackend.options.length] = new Option(pair.value, pair.key);
        });

        $A(['ldap', 'activeD', 'domino', 'mysql', 'mssql', 'hanaDb', 'office365', 'google', 'infusionsoft', 'exchange', 'csv']).each( (backend) => {
            this.pSyncPlaceSyncSettings(backend);
        });

        this.pSyncPlaceSyncMap(this.pSyncCurrBackend);
        this.pSyncPlaceSyncRecurrentJob();
        this.pSyncChangeBackend(this.pSyncCurrBackend);
        this.pSyncChangeCsvImportType($F('p_s_backend_csv_import_type'));

    },

    this.pSyncPlaceSyncSettings = function (backend) {
        $H(this.pSyncSettingsAndMap[backend+'_settings']).each(function (pair) {
            if ($('p_s_backend_' + backend + '_' + pair.key + '')) {
                if ($('p_s_backend_' + backend + '_' + pair.key + '').type == 'checkbox') {
                    if (pair.value == 'yes') {
                        $('p_s_backend_' + backend + '_' + pair.key + '').checked = true;
                    } else {
                        $('p_s_backend_' + backend + '_' + pair.key + '').checked = false;
                    }
                } else {
                    $('p_s_backend_' + backend + '_' + pair.key + '').value = pair.value;
                    if ($('p_s_backend_' + backend + '_' + pair.key + '_text')) {
                        $('p_s_backend_' + backend + '_' + pair.key + '_text').innerHTML = pair.value;
                    }
                }
            }
        });
    },

    this.pSyncPlaceSyncMap = function(backend) {
        // disable all here
        var def = {};
        if (('default' in this.pSyncSettingsAndMap) && (backend in this.pSyncSettingsAndMap['default']['map'])) {
            def = this.pSyncSettingsAndMap['default'][backend+'_map'];
        }

        $A(this.pSyncFields).each(function (val) {
            $('ps_map_' + val + '').value = def[val] || '';
            if (val != 'username' && val != 'source_id') {
                $('ps_map_' + val + '').disabled   = true;
                $('ps_map_' + val + '_on').value   = '0';
                $('ps_map_' + val + '_on').checked = false;
            }
        });
        $H(this.pSyncSettingsAndMap[backend+'_map']).each(function (pair) {
            $('ps_map_' + pair.key + '').value      = pair.value;
            $('ps_map_' + pair.key + '').disabled   = false;
            $('ps_map_' + pair.key + '_on').value   = '1';
            $('ps_map_' + pair.key + '_on').checked = true;
        });

        $('ps_map_username_on').disabled  = true;
        $('ps_map_source_id_on').disabled = true;
    },

    this.pSyncPlaceSyncRecurrentJob = function() {
        if (this.pSyncSettingsAndMap['recurrent_job']['enabled'] == 'yes') {
            $('ps_recurrent_on').checked        = true;
            $('ps_recurrent_on').value          = 1;
            $('ps_recurrent_interval').disabled = false;
            $('ps_recurrent_interval').value    = this.pSyncSettingsAndMap['recurrent_job']['interval'];
            $('ps_recurrent_email').disabled    = false;
            $('ps_recurrent_email').value       = this.pSyncSettingsAndMap['recurrent_job']['email'];
        } else {
            $('ps_recurrent_on').checked        = false;
            $('ps_recurrent_on').value          = 0;
            $('ps_recurrent_interval').value    = '1';
            $('ps_recurrent_interval').disabled = true;
            $('ps_recurrent_email').value       = '';
            $('ps_recurrent_email').disabled    = true;
        }
    },

    this.pSyncChangeBackend = function (backend) {
        // set pSyncSettingsAndMap['map'][pSyncCurrBackend]
        $A(this.pSyncFields).each( (val) => {
            if ($('ps_map_' + val + '_on').checked && $F('ps_map_' + val) != '') {
                this.pSyncSettingsAndMap[this.pSyncCurrBackend+'_map'][val] = $F('ps_map_' + val + '');
            } else {
                delete this.pSyncSettingsAndMap[this.pSyncCurrBackend+'_map'][val];
            }
        });
        this.pSyncCurrBackend = backend;
        $$('#phonebooks_sync_backend_settings tr.p_s_backend_ldap').invoke('hide');
        $$('#phonebooks_sync_bottom tr.p_s_backend_ldap').invoke('hide');

        $$('#phonebooks_sync_backend_settings tr.p_s_backend_activeD').invoke('hide');
        $$('#phonebooks_sync_bottom tr.p_s_backend_activeD').invoke('hide');

        $$('#phonebooks_sync_backend_settings tr.p_s_backend_domino').invoke('hide');
        $$('#phonebooks_sync_bottom tr.p_s_backend_domino').invoke('hide');

        $$('#phonebooks_sync_backend_settings tr.p_s_backend_mysql').invoke('hide');
        $$('#phonebooks_sync_bottom tr.p_s_backend_mysql').invoke('hide');

        $$('#phonebooks_sync_backend_settings tr.p_s_backend_hanaDb').invoke('hide');
        $$('#phonebooks_sync_bottom tr.p_s_backend_hanaDb').invoke('hide');

        $$('#phonebooks_sync_backend_settings tr.p_s_backend_mssql').invoke('hide');
        $$('#phonebooks_sync_bottom tr.p_s_backend_mssql').invoke('hide');

        $$('#phonebooks_sync_backend_settings tr.p_s_backend_csv').invoke('hide');
        $$('#phonebooks_sync_bottom tr.p_s_backend_csv').invoke('hide');

        $$('#phonebooks_sync_backend_settings tr.p_s_backend_office365').invoke('hide');
        $$('#phonebooks_sync_bottom tr.p_s_backend_office365').invoke('hide');
        $$('#phonebooks_sync_backend_settings tr.p_s_hint_office365').invoke('hide');

        $$('#phonebooks_sync_backend_settings tr.p_s_backend_google').invoke('hide');
        $$('#phonebooks_sync_bottom tr.p_s_backend_google').invoke('hide');
        $$('#phonebooks_sync_backend_settings tr.p_s_hint_google').invoke('hide');

        $$('#phonebooks_sync_backend_settings tr.p_s_backend_infusionsoft').invoke('hide');
        $$('#phonebooks_sync_bottom tr.p_s_backend_infusionsoft').invoke('hide');
        $$('#phonebooks_sync_backend_settings tr.p_s_hint_infusionsoft').invoke('hide');

        $$('#phonebooks_sync_backend_settings tr.p_s_backend_exchange').invoke('hide');
        $$('#phonebooks_sync_bottom tr.p_s_backend_exchange').invoke('hide');
        $$('#phonebooks_sync_backend_settings tr.p_s_hint_exchange').invoke('hide');

        if (backend === 'csv' && (this.varsPhp.isWcloud || !$H(cSyncMounts).size())) {
            $$('#phonebooks_sync_recurrent').invoke('hide');
            $('ps_recurrent_on').checked = false;
        }
        else {
            $$('#phonebooks_sync_recurrent').invoke('show');
        }

        var settings = null;
        if (backend === 'office365') {
            settings = this.pSyncSettingsAndMap[backend+'_settings'];
            _loadOffice365Phonebooks({
                token: {
                    'access_token': settings.access_token,
                    'expires_in': settings.expires_in,
                    'received_token_time': settings.received_token_time,
                    'id_token': settings.id_token,
                    'id_token_expires_in': settings.id_token_expires_in,
                    'refresh_token': settings.refresh_token,
                    'token_type': settings.token_type
                }
            });
        } else if (backend === 'google') {
            settings = this.pSyncSettingsAndMap[backend+'_settings'];
            _loadGooglePhonebooks({
                token: {
                    'access_token': settings.access_token,
                    'expires_in': settings.expires_in,
                    'received_token_time': settings.received_token_time,
                    'refresh_token': settings.refresh_token,
                    'token_type': settings.token_type
                }
            });
        } else if (backend === 'infusionsoft') {
            settings = this.pSyncSettingsAndMap[backend+'_settings'];
            _setInfusionsoftAuthCredentials({
                userInfo: {
                    email: settings.mail,
                    app: settings.app
                },
                token: {
                    access_token: settings.access_token,
                    expires_in: settings.expires_in,
                    received_token_time: settings.received_token_time,
                    refresh_token: settings.refresh_token,
                    token_type: settings.token_type
                }
            });
        } else if (backend === 'exchange') {
            settings = this.pSyncSettingsAndMap[backend+'_settings'];
            _loadExchangePhonebooks();
        }

        $$('#phonebooks_sync_backend_settings tr.p_s_backend_' + backend).invoke('show');
        $$('#phonebooks_sync_backend_settings tr.p_s_hint_' + backend).invoke('show');
        $$('#phonebooks_sync_bottom tr.p_s_backend_' + backend).invoke('show');
        this.pSyncPlaceSyncMap(backend);
    },

    this.pSyncChangeCsvImportType = function (val) {
        if (val == 'share') {
            $('p_s_backend_csv_import_type_upload').hide();
            $('p_s_backend_csv_import_type_share').show();
        } else {
            $('p_s_backend_csv_import_type_upload').show();
            $('p_s_backend_csv_import_type_share').hide();
        }
    };

    this.pSyncDoSync = function (dry_run, verbose) {

        if (!this.validateImportForm()) {
            return false;
        }

        if (!this.checkNameAndId()) {
            return false;
        }

        var syncid      = Math.random().toString().substring(3, 8);
        var backend     = $F('p_s_backend_backend');
        var pbook_id    = $F('p_s_phonebook_id');
        var go_settings = this.pSyncReadSettings(backend);

        //save setting
        var sync_save_request = this.pSyncDoSave();

        sync_save_request.options.onComplete = (transport) => {

            go_settings['global'] = {"remove_users": "no", "erase_values": "no"};
            if ($('p_s_global_remove_users').checked) {
                go_settings['global']['remove_users'] = 'yes';
            }
            if ($('p_s_global_erase_values').checked) {
                go_settings['global']['erase_values'] = 'yes';
            }

            $$('span.err_span').invoke('remove');
            // check share is present for csv
            if (backend == 'csv' && $F('p_s_backend_csv_import_type') == 'share' && !$F('p_s_backend_csv_import_mountpoint')) {
                raiseErrors({'p_s_backend_csv_import_mountpoint': WMS._t('rules.enterValidValue')}, ' ');
                return false;
            }

            if (go_settings['settings']['backend'] === 'csv' && $F('p_s_backend_csv_import_type') === 'upload') {
                go_settings['dry_run']            = dry_run;
                go_settings['verbose']            = verbose;
                go_settings['syncid']             = syncid;
                go_settings['pbook_id']           = pbook_id;
                $('p_s_backend_csv_params').name  = 'p_s_backend_csv_params';
                $('p_s_backend_csv_params').value = $H(go_settings).toJSON();
                var form                          = $('phonebooks_sync_backend_settings_filter_form');
                var rez                           = AIM.submit(
                    form,
                    {
                        'onStart': this.pSyncUplCsvStartCallback,
                        'onComplete': (response) => {
                            if (response !== '') {
                                oResponse = eval("(" + response + ")");
                                if (oResponse === true) {
                                    this.pSyncStartShowLog(syncid, pbook_id);
                                } else if (oResponse.ERRORS) {
                                    ap_showWaitMessage('waitDiv', 0);
                                    raiseErrors({'p_s_backend_csv_fileid': oResponse.ERRORS}, ' ');
                                } else {
                                    ap_showWaitMessage('waitDiv', 0);
                                    raiseErrors(oResponse, ' ');
                                }
                            } else {
                                ap_showWaitMessage('waitDiv', 0);
                                raiseErrors({'p_s_backend_csv_fileid': 'Upload error'}, ' ');
                            }
                        }
                    }
                );
                if (!rez) {
                    return false;
                } else {
                    form.submit();
                    return true;
                }
            }

            ap_showWaitMessage('waitDiv', 1);
            return new Ajax.Request('aclpbx/index.php', {
                method: 'post',
                parameters: $H({
                    "action": 'phonebook_sync',
                    "dry_run": dry_run,
                    "verbose": verbose,
                    "syncid": syncid,
                    "pbook_id": pbook_id,
                    "settings": $H(go_settings).toJSON()
                }).toQueryString(),
                onComplete: (transport) => {
                    this.pSyncStartShowLog(syncid, pbook_id);
                }
            });

        }
    };

    this.pSyncUplCsvStartCallback = function () {
        $$('span.err_span').invoke('remove');
        ok = $A(['p_s_backend_csv_fileid']).inject([], function (a, n) {
            if ($(n).value != '') a.push($(n).value);
            return a;
        }).all(function (value) {
            return ['.csv'].any(function (extension) {
                return value.endsWith(extension.toLowerCase());
            });
        });
        if (!ok || $F('p_s_backend_csv_fileid') == '') {
            raiseErrors({'p_s_backend_csv_fileid': 'Valid format: csv'}, ' ');
            ap_showWaitMessage('waitDiv', 0);
            return false;
        } else {
            return true;
        }
    };

    this.pSyncStartShowLog = function(syncid, pbook_id) {
        $('phonebooks_sync_settings_div').hide();
        $('phonebooks_sync_log_div').update('&nbsp');
        $('phonebooks_sync_log_div').show();
        $('phonebooks_sync_div_buttons_settings').hide();
        $('phonebooks_sync_div_buttons_test').show();
        $('ps_btn_back').setAttribute('disabled', true);

        ap_showWaitMessage('waitDiv', 0);

        this.pSyncUpdater = new Ajax.PeriodicalUpdater(false/* stop */, 'monit/log/?act=show_phonebook_sync&syncid=' + syncid + '&pbook_id=' + pbook_id + '&pbook_ver=3', {
            method: 'get',
            frequency: 2,
            decay: 1,
            onSuccess: (t) => {
                if (t.status == '200') {
                    if (t.responseText != '') {
                        var t_arr       = t.responseText.split("\n");
                        var t_completed = false;
                        for (var t_cnt = 0, t_length = t_arr.length; t_cnt < t_length; t_cnt++) {
                            if (t_arr[t_cnt].indexOf('The operation is completed.') != -1 || t_arr[t_cnt].indexOf('No change was provided.') != -1) {
                                t_completed = true;
                            }
                        }
                        $('phonebooks_sync_log_div').update(t_arr.join("<br /><br />") + (t_completed ? "" : '<div style="background-color:#233259;color:#d5d5d3;font-size:11px;height:20px;font-weight:bold">' + WMS._t('strings.Proceeding') + '...</div>'));
                        t_arr = null;
                        if (t_completed) {
                            this.pSyncUpdater.stop();
                            $('ps_btn_back').removeAttribute('disabled');
                        }
                    }
                }
            }
        });
    };

    this.pSyncBack = function() {
        this.pSyncUpdater.stop();
        $('phonebooks_sync_settings_div').show();
        $('phonebooks_sync_log_div').update('&nbsp');
        $('phonebooks_sync_log_div').hide();
        $('phonebooks_sync_div_buttons_settings').show();
        $('phonebooks_sync_div_buttons_test').hide();
    };

    this.pSyncReadSettings = function (backend) {
        var t_settings = {'backend': backend};
        $H(this.pSyncSettingsAndMap[backend+'_settings']).each( (pair) => {
            if ($('p_s_backend_' + backend + '_' + pair.key + '')) {
                if ($('p_s_backend_' + backend + '_' + pair.key + '').type == 'checkbox') {
                    if ($('p_s_backend_' + backend + '_' + pair.key + '').checked) {
                        t_settings[pair.key] = 'yes';
                    } else {
                        t_settings[pair.key] = 'no';
                    }
                } else {
                    t_settings[pair.key] = $F('p_s_backend_' + backend + '_' + pair.key + '');
                }
            }
        });
        // get map
        var t_map = {}
        $A(this.pSyncFields).each( (val) => {
            if ($('ps_map_' + val + '_on').checked && $F('ps_map_' + val) != '') {
                t_map[val] = $F('ps_map_' + val + '');
            }
        });
        return {'settings': t_settings, 'map': t_map};
    };

    this.validateImportForm = function () {

        var errors = {};
        jQuery('#phonebooks_sync_backend_settings_form input').css('border-color', '');
        if ($F('p_s_backend_backend') == 'mssql') {
            if ($F('p_s_backend_mssql_host') == '') {
                errors['p_s_backend_mssql_host'] = false;
            }

            if (!$F('p_s_backend_mssql_timeout').match(/^\d*$/)) {
                errors['p_s_backend_mssql_timeout'] = false;
            }

            if (!$F('p_s_backend_mssql_port').match(/^\d*$/)) {
                errors['p_s_backend_mssql_port'] = false;
            }
        }

        if ($F('p_s_backend_backend') == 'mysql') {
            if (!($F('p_s_backend_mysql_host') != '' && ($F('p_s_backend_mysql_host').match(/^([a-zA-Z0-9]([a-zA-Z0-9\-]{0,61}[a-zA-Z0-9])?\.)+[a-zA-Z]{2,6}$/) || $F('p_s_backend_mysql_host').match(/^((25[0-5]|2[0-4]\d|[01]?\d\d?)\.){3}(25[0-5]|2[0-4]\d|[01]?\d\d?)$/)))) {
                errors['p_s_backend_mysql_host'] = false;
            }

            if (!$F('p_s_backend_mysql_port').match(/^\d*$/)) {
                errors['p_s_backend_mysql_port'] = false;
            }
        }

        if ($F('p_s_backend_backend') == 'ldap') {
            if (!($F('p_s_backend_ldap_host') != '' && ($F('p_s_backend_ldap_host').match(/^([a-zA-Z0-9]([a-zA-Z0-9\-]{0,61}[a-zA-Z0-9])?\.)+[a-zA-Z]{2,6}$/) || $F('p_s_backend_ldap_host').match(/^((25[0-5]|2[0-4]\d|[01]?\d\d?)\.){3}(25[0-5]|2[0-4]\d|[01]?\d\d?)$/)))) {
                errors['p_s_backend_ldap_host'] = false;
            }

            if (!$F('p_s_backend_ldap_port').match(/^\d*$/)) {
                errors['p_s_backend_ldap_port'] = false;
            }
        }
        if ($F('p_s_backend_backend') == 'hanaDb') {
            if (!($F('p_s_backend_hanaDb_host') != '' && ($F('p_s_backend_hanaDb_host').match(/^([a-zA-Z0-9]([a-zA-Z0-9\-]{0,61}[a-zA-Z0-9])?\.)+[a-zA-Z]{2,6}$/) || $F('p_s_backend_hanaDb_host').match(/^((25[0-5]|2[0-4]\d|[01]?\d\d?)\.){3}(25[0-5]|2[0-4]\d|[01]?\d\d?)$/)))) {
                errors['p_s_backend_hanaDb_host'] = false;
            }

            if (!$F('p_s_backend_hanaDb_port').match(/^\d*$/)) {
                errors['p_s_backend_hanaDb_port'] = false;
            }
        }

        if ($F('p_s_backend_backend') == 'activeD') {
            if (!($F('p_s_backend_activeD_host') != '' && ($F('p_s_backend_activeD_host').match(/^([a-zA-Z0-9]([a-zA-Z0-9\-]{0,61}[a-zA-Z0-9])?\.)+[a-zA-Z]{2,6}$/) || $F('p_s_backend_activeD_host').match(/^((25[0-5]|2[0-4]\d|[01]?\d\d?)\.){3}(25[0-5]|2[0-4]\d|[01]?\d\d?)$/)))) {
                errors['p_s_backend_activeD_host'] = false;
            }

            if (!$F('p_s_backend_activeD_port').match(/^\d*$/)) {
                errors['p_s_backend_activeD_port'] = false;
            }
        }

        if ($F('p_s_backend_backend') == 'domino') {
            if (!($F('p_s_backend_domino_host') != '' && ($F('p_s_backend_domino_host').match(/^([a-zA-Z0-9]([a-zA-Z0-9\-]{0,61}[a-zA-Z0-9])?\.)+[a-zA-Z]{2,6}$/) || $F('p_s_backend_domino_host').match(/^((25[0-5]|2[0-4]\d|[01]?\d\d?)\.){3}(25[0-5]|2[0-4]\d|[01]?\d\d?)$/)))) {
                errors['p_s_backend_domino_host'] = false;
            }

            if (!$F('p_s_backend_domino_port').match(/^\d*$/)) {
                errors['p_s_backend_domino_port'] = false;
            }
        }

        if ($F('p_s_backend_backend') == 'exchange') {
            if (!($F('p_s_backend_exchange_host') != '' && ($F('p_s_backend_exchange_host').match(/^([a-zA-Z0-9]([a-zA-Z0-9\-]{0,61}[a-zA-Z0-9])?\.)+[a-zA-Z]{2,6}$/) || $F('p_s_backend_exchange_host').match(/^((25[0-5]|2[0-4]\d|[01]?\d\d?)\.){3}(25[0-5]|2[0-4]\d|[01]?\d\d?)$/)))) {
                errors['p_s_backend_exchange_host'] = false;
            }

            if (!($F('p_s_backend_exchange_user') != '')) {
                errors['p_s_backend_exchange_user'] = false;
            }
            if (!($F('p_s_backend_exchange_password') != '')) {
                errors['p_s_backend_exchange_password'] = false;
            }
        }

        if ($H(errors).size() > 0) {
            $H(errors).each(function (pair) {
                jQuery('#' + pair.key).css('border-color', '#FF0000');
            });
            return false;
        }

        return true;
    };

    this.pSyncDoSave = function () {

        var t_backend   = $F('p_s_backend_backend');
        var go_settings = {"global": {"backend": t_backend, "remove_users": "no", "erase_values": "no"}};
        if ($('p_s_global_remove_users').checked) {
            go_settings['global']['remove_users'] = 'yes';
        }
        if ($('p_s_global_erase_values').checked) {
            go_settings['global']['erase_values'] = 'yes';
        }
        var pbook_id = $F('p_s_phonebook_id');

        if (!this.checkNameAndId()) {
            return false;
        }

        $$('span.err_span').invoke('remove');
        // no recurrent job for csv
        if (t_backend == 'csv' && $('ps_recurrent_on').checked && $F('p_s_backend_csv_import_type') == 'upload') {
            raiseErrors({'ps_recurrent_on': WMS._t('aclpbx.noRecurrentSyncForCsv')});
            return false;
        }
        // check share is present for csv
        if (t_backend == 'csv' && $F('p_s_backend_csv_import_type') == 'share' && !$F('p_s_backend_csv_import_mountpoint')) {
            raiseErrors({'p_s_backend_csv_import_mountpoint': WMS._t('rules.enterValidValue')}, ' ');
            return false;
        }

        $A(['ldap', 'activeD', 'domino', 'mysql', 'mssql', 'hanaDb', 'office365', 'google', 'infusionsoft', 'exchange', 'csv']).each((backend) => {
            go_settings[backend] = this.pSyncReadSettings(backend);
            if (t_backend != backend) {
                go_settings[backend]['map'] = this.pSyncSettingsAndMap[backend+'_map'];
            }
        });

        go_settings['recurrent_job'] = {};
        if ($('ps_recurrent_on').checked) {
            go_settings['recurrent_job']['enabled']  = 'yes';
            go_settings['recurrent_job']['interval'] = $F('ps_recurrent_interval');
            go_settings['recurrent_job']['email']    = $F('ps_recurrent_email');
        } else {
            go_settings['recurrent_job']['enabled'] = 'no';
        }

        ap_showWaitMessage('waitDiv', 1);
        return new Ajax.Request('aclpbx/index.php', {
            method: 'post',
            parameters: $H({
                "action": 'phonebook_sync_save',
                "pbook_id": pbook_id,
                "settings": $H(go_settings).toJSON()
            }).toQueryString(),
            onComplete: () => {
                $('loading').hide();
            }
        });
    };

    this.checkNameAndId = function() {
        $('ps_map_username').setStyle({'border-color': '#ccc'});
        $('ps_map_source_id').setStyle({'border-color': '#ccc'});
        if ($F('ps_map_username') == '') {
            $('ps_map_username').setStyle({'border-color': '#FF0000'});
            return false;
        }
        if ($F('ps_map_source_id') == '') {
            $('ps_map_source_id').setStyle({'border-color': '#FF0000'});
            return false;
        }
        return true;
    };

    this.pDownloadAllSyncLog = function (selectedRows) {
        const pObj = selectedRows[0];
        if (pObj && pObj.id) {
            window.location = "aclpbx/index.php?download_all_sync_phonbook_log=1&rid=" + pObj.id;
        }
    };

    this.pSyncToggleMapAttr = function (el, id) {
        $(id)[el.checked ? 'enable' : 'disable']();
        el.value = el.checked ? 1 : 0;
    };

    this.pSyncToggleRecurrentJob = function (el, id1, id2) {
        this.pSyncToggleMapAttr(el, id1);
        this.pSyncToggleMapAttr(el, id2);
    };

    initialize(data);
};
