WMS.Users = function(data) {
    this.syncGoogleAuthUrlAvailable = false;
    this.syncGoogleAuthUrl = ''

    this.office365AuthUrlAvailable = false
    this.office365AuthUrl = ''

    this.zohoCrmAuthUrlAvailable = false
    this.zohoCrmAuthUrl = ''

    initialize = (varsPhp) => {
        this.varsPhp = varsPhp;
        this.DataTable  = {CLASS_ASC: 'yui-dt-asc'}
        this.table = null;
        this.modwin = null;
        this.modsecwin = null;

        this.usSyncSettingsAndMap = usSyncSettingsAndMap;
        this.usSyncFields = this.varsPhp.usSyncFields;
    };

    this.unselectForPasswords = function(selectedRows=[]){
        var adminIsPresent = false;
        var errors = [];

        selectedRows.forEach((record) => {
            if (record['name'].toLowerCase() == this.varsPhp.currentAdmin) {
                adminIsPresent = true;
            }
        });

        if (this.varsPhp.currentAdmin == 'admin'){
            if (adminIsPresent){
                selectedRows.forEach((record) => {
                    if (record['name'].toLowerCase() != this.varsPhp.currentAdmin) {
                        errors.push(record.getData('cn'));
                    }
                });
            }
        }else{
            if (adminIsPresent){
                selectedRows.forEach((record) => {
                    if (record['name'].toLowerCase() != this.varsPhp.currentAdmin) {
                        errors.push(record['name']);
                    }
                });
            }else{
                selectedRows.forEach((record) => {
                    if (record['name'].toLowerCase() != this.varsPhp.currentAdmin && (record['name'].toLowerCase() == 'admin' || record['role'] == 'admin')) {
                        errors.push(record['name']);
                    }
                });
            }
        }

        if(errors.length>0){
            setError('warning', WMS._t('aclpbx.NoPermissionForUsers') + ':<br />'+errors.join("<br />"));
        }
    };

    this.sendInviteXbees = function(selectedRows=[]) {

        const usersByLanguage = this.getSelectedUsersByLanguages(selectedRows)
        let no_email = [];

        selectedRows.forEach((record) => {
            if(!record['email']){
                no_email.push(record['name']);
            }
        })

        if(no_email.length>0) {
            setError('error', WMS._t('aclpbx.NoEmailError') + no_email.join(', '));
        }

        for(const language in usersByLanguage) {
            ap_showWaitMessage('waitDiv', 1);
            const userids = usersByLanguage[language];
            new Ajax.Request('aclpbx/index.php?lang=' + language, {
                method: 'post',
                parameters: {
                    userid: userids.sort().join('|') || "0",
                    action: 'sendWelcomeEmailXbees'
                },
                onComplete: () => {
                    ap_showWaitMessage('waitDiv', 0);
                }
            });
        }
    };

    this.sendWelcome = async function(selectedRows = []) {

        this.unselectForPasswords();

        const usersByLanguage = this.getSelectedUsersByLanguages(selectedRows)
        const sendEmailByLang = (language, userids) => {
            return new Promise((resolve, reject) => {
                let content = '';
                new Ajax.Request(('data/templates/WelcomeMailTemplate.php?lang=' + language) ,{
                    onComplete: (transport) => {
                        //Show loader (??)
                        ap_showWaitMessage('waitDiv', 0);

                        if(transport) {
                            //Save html template from the response
                            content = transport.responseText;

                            let frame = '<iframe id="iframe_box" src="about:blank" style="width: 684px; height: 480px;"></iframe>'
                            this.showDialog(686, 480, frame, () => {

                                let no_email = [];

                                selectedRows.forEach(function(record){
                                    const uid = record['id'];
                                    if(userids.indexOf(uid) !== -1) {
                                        if( ! record['email']){
                                            no_email.push(record['name']);
                                        }
                                    }
                                })

                                if(no_email.length>0){//Insert email address for user(s)
                                    setError('error', WMS._t('aclpbx.NoEmailError') + no_email.join(', '));
                                }

                                const iframe = document.getElementById('iframe_box').contentWindow.document;

                                // get template from iframe
                                const serializer = new XMLSerializer();
                                const mailTmpl = serializer.serializeToString(iframe);

                                ap_showWaitMessage('waitDiv', 1);

                                new Ajax.Request('aclpbx/index.php',{
                                    method: 'post',
                                    parameters: {
                                        userid: userids.sort().join('|') || "0",
                                        action: 'sendWelcomeEmail',
                                        template: mailTmpl
                                    }, //$F('email_tpl')},
                                    onComplete: (t) => {
                                        ap_showWaitMessage('waitDiv', 0);
                                        this.modwin.close();
                                        this.modwin = null;
                                        setTimeout( () => {
                                            resolve();
                                        }, 100)
                                    }
                                });
                            }, false, true, function () {
                                setTimeout(function () {
                                    resolve();
                                }, 100)
                            }).setHeader(WMS._t('aclpbx.editEmailBody'));

                            // hack for once remove empty strings
                            let runOnce;

                            // open template in iframe for save all html tags
                            let iframe = document.getElementById('iframe_box').contentWindow.document;
                            iframe.open();
                            iframe.write(content);
                            iframe.close();

                            let edititableTmpl = iframe.getElementById('tmpl_data');
                            edititableTmpl.addEventListener('click', () => {

                                let tmplContentDiv = iframe.getElementById('tmpl_content');
                                let tmplContent = tmplContentDiv.innerHTML;
                                // change <br> to '\n' and remove empty lines
                                tmplContent = tmplContent.replace(/<br ?\/?>/g, '\n');

                                // hack
                                if (runOnce === undefined) {
                                    tmplContent = tmplContent.replace(/\n\n/g, '\n');
                                    runOnce = true;
                                }

                                // prepare second dialog for edit customer data
                                let content = '<textarea id="email_tpl" style="margin: 5px; width: 475px;height:335px">' + tmplContent  + '</textarea>';

                                this.showSecondDialog(500, 400, content, function(){

                                    var customData = $F('email_tpl');
                                    // change '\n' to <br>
                                    customData = customData.split('\n').join('<br />');
                                    tmplContentDiv.innerHTML = customData;

                                    // close dialog;
                                    this.modsecwin.close();
                                    this.modsecwin =null;

                                }, false, true).setHeader(WMS._t('aclpbx.editEmailBody'));
                            }, false);
                        }
                        else {
                            reject();
                        }
                    }
                });
            })
        }

        for(const lang in usersByLanguage) {
            await sendEmailByLang(lang, usersByLanguage[lang]);
        }
    };

    this.getSelectedUsersByLanguages = function (selectedRows = []) {
        let result = {};

        selectedRows.forEach( (record) => {
            const preferredLanguage = record['language'];
            if (!result.hasOwnProperty(preferredLanguage)) {
                result[preferredLanguage] = [];
            }
            result[preferredLanguage].push(record['id'])
        });
        return result;
    };

    this.initForm = function () {
        this.uSyncUpdater;
        this.uSyncCurrBackend;

        this.usSyncSetFrom({});

        Event.observe($('u_s_backend_backend'),'change',(event) => {
            this.uSyncChangeBackend(Event.element(event).value);
        });

        Event.observe($('u_s_backend_csv_import_type'),'change', (event) => {
            this.uSyncChangeCsvImportType(Event.element(event).value);
        });

        Event.observe($('us_recurrent_on'),'click', (event) => {
            this.uSyncToggleRecurrentJob(Event.element(event),'us_recurrent_interval','us_recurrent_email');
        });

        $('u_s_backend_office365_login').onclick = _onClickOffice365Login;
        $('u_s_backend_office365_logout').onclick = _onClickOffice365Logout;

        $('u_s_backend_zohoCrm_login').onclick = _onClickZohoCrmLogin;
        $('u_s_backend_zohoCrm_logout').onclick =_onClickZohoCrmLogout;

        $('u_s_backend_google_login').onclick = _onClickGoogleLogin;
        $('u_s_backend_google_logout').onclick = _onClickGoogleLogout;

        Array.from(document.getElementsByClassName('uSyncToggleMapAttr')).forEach((e) => {
            e.onclick = (event) => {
                this.uSyncToggleMapAttr(Event.element(event), Event.element(event).id.slice(0,-3));
            };
        });
    };

    const _onClickOffice365Login = (event) => {

        window.callbackOffice365FunctionContacts = _onOffice365LoginCallback;

        if (this.office365AuthUrlAvailable) {
            window.open(
                    this.office365AuthUrl,
                    "Office365 sing on",
                    "location=0,status=0,scrollbars=0,width=800,height=500"
            );
        } else {
            setError('error', 'Office365 Auth url unavailable');
        }
    };

    const _onClickZohoCrmLogin = (event) => {
        window.callbackZohoCrmFunctionContacts = _onZohoCrmLoginCallback;

        if (this.zohoCrmAuthUrlAvailable) {
            window.open(
                    this.zohoCrmAuthUrl,
                    "ZohoCRM sing on",
                    "location=0,status=0,scrollbars=0,width=800,height=500"
            );
        } else {
            setError('error', 'ZohoCrm Auth url unavailable');
        }
    };

    const _onClickOffice365Logout = (event) => {
        $('u_s_backend_office365_mail').value = '';
        $('u_s_backend_office365_mail_text').innerHTML = '';
        $('u_s_backend_office365_received_token_time').value = '';
        $('u_s_backend_office365_access_token').value = '';
        $('u_s_backend_office365_token_type').value = '';
        $('u_s_backend_office365_expires_in').value = '';
        $('u_s_backend_office365_id_token').value = '';
        $('u_s_backend_office365_id_token_expires_in').value = '';
        $('u_s_backend_office365_refresh_token').value = '';
        $('u_s_backend_office365_logout').hide();
        $('u_s_backend_office365_login').show();

        this.uSyncDoSave();
    };

    const _onClickZohoCrmLogout = (event) => {
        var parameters = {
            refresh_token: $('u_s_backend_zohoCrm_refresh_token').value,
            api_domain: $('u_s_backend_zohoCrm_api_domain').value,
            action: 'zohoCrm_revoke_token'
        };

        new Ajax.Request('aclpbx/index.php',{
            method: 'post',
            parameters: parameters,
            onSuccess: function(transport) {

                urls[type] = transport.responseJSON;
                success(urls[type]);
            },
            onFailure: function (transport) {
                error(transport.responseJSON);
            }
        });

        $('u_s_backend_zohoCrm_full_name').value = '';
        $('u_s_backend_zohoCrm_full_name_text').innerHTML = '';
        $('u_s_backend_zohoCrm_received_token_time').value = '';
        $('u_s_backend_zohoCrm_access_token').value = '';
        $('u_s_backend_zohoCrm_token_type').value = '';
        $('u_s_backend_zohoCrm_expires_in').value = '';
        $('u_s_backend_zohoCrm_refresh_token').value = '';
        $('u_s_backend_zohoCrm_location').value = '';
        $('u_s_backend_zohoCrm_api_domain').value = '';
        $('u_s_backend_zohoCrm_accounts_server').value = '';
        $('u_s_backend_zohoCrm_logout').hide();
        $('u_s_backend_zohoCrm_login').show();

        this.uSyncDoSave();
    };

    const _onOffice365LoginCallback = (result) => {
        if(!result){
            // error
            return;
        }
        if(result.error && result.error != '' && result.error_description){
            if(result.error_description){
                setError('error', result.error_description);
            }else{
                // unknow
            }
        }else if(result.token && result.userInfo){
            _onOffice365LoadToken(result);
        }
    };

    const _onZohoCrmLoginCallback = (result) => {
        if(!result){
            // error
            return;
        }
        if(result.error && result.error != '' && result.error_description){
            if(result.error_description){
                setError('error', result.error_description);
            }else{
                // unknow
            }
        }else if(result.token && result.userInfo){
            _onZohoCrmLoadToken(result);
            this.uSyncDoSave()
        }
    };

    const _onOffice365LoadToken = (result) => {
        getOffice365AuthUrl('users', (response) => {
            this.office365AuthUrlAvailable = true;
            this.office365AuthUrl = response.url;

            if(result.userInfo && result.userInfo.preferred_username) {
                $('u_s_backend_office365_mail').value = result.userInfo.preferred_username;
                $('u_s_backend_office365_mail_text').innerHTML = result.userInfo.preferred_username;
            }
            if(result.token && result.token.id_token){
                $('u_s_backend_office365_received_token_time').value = result.token.received_token_time;
                $('u_s_backend_office365_access_token').value = result.token.access_token;
                $('u_s_backend_office365_token_type').value = result.token.token_type;
                $('u_s_backend_office365_expires_in').value = result.token.expires_in;
                $('u_s_backend_office365_id_token').value = result.token.id_token;
                $('u_s_backend_office365_id_token_expires_in').value = result.token.id_token_expires_in;
                $('u_s_backend_office365_refresh_token').value = result.token.refresh_token;
                $('u_s_backend_office365_logout').show();
                $('u_s_backend_office365_login').hide();
            }

        });
    };

    const _onZohoCrmLoadToken = (result) => {
        getZohoCrmAuthUrl('ZohoCRM.users.ALL', (response) => {
            this.zohoCrmAuthUrlAvailable = true;
            this.zohoCrmAuthUrl = response.url;

            if(result.userInfo && result.userInfo.full_name) {
                $('u_s_backend_zohoCrm_full_name').value          = result.userInfo.full_name;
                $('u_s_backend_zohoCrm_full_name_text').innerHTML = result.userInfo.full_name;
            }
            if (result.token && result.token.access_token) {
                $('u_s_backend_zohoCrm_received_token_time').value = result.token.received_token_time;
                $('u_s_backend_zohoCrm_access_token').value        = result.token.access_token;
                $('u_s_backend_zohoCrm_token_type').value          = result.token.token_type;
                $('u_s_backend_zohoCrm_expires_in').value          = result.token.expires_in;
                $('u_s_backend_zohoCrm_api_domain').value          = result.token.api_domain;
                $('u_s_backend_zohoCrm_refresh_token').value       = result.token.refresh_token;
                $('u_s_backend_zohoCrm_accounts_server').value     = result.token.accounts_server;

                if (result.token.location) {
                    $('u_s_backend_zohoCrm_location').value = result.token.location;
                } else {
                    $('u_s_backend_zohoCrm_location').value = this.usSyncSettingsAndMap['settings']['zohoCrm']['location'];
                }

                $('u_s_backend_zohoCrm_logout').show();
                $('u_s_backend_zohoCrm_login').hide();
            }

        });
    };

    const _onClickGoogleLogin = (event) => {
        var windowOpen =  (syncGoogleAuthUrl) => {
            window.open(
                syncGoogleAuthUrl,
        "Google sing on",
        "location=0,status=0,scrollbars=0,width=800,height=500"
            );
        };

        window.callbackFunctionUsers = _onGoogleLoginCallback;

        if (this.syncGoogleAuthUrlAvailable) {
            windowOpen(this.syncGoogleAuthUrl);
        } else {
            setError('error', 'Google Auth url unavailable');
        }
    };

    const _onClickGoogleLogout = (event) => {
        $('u_s_backend_google_mail').value = '';
        $('u_s_backend_google_mail_text').innerHTML = '';
        $('u_s_backend_google_received_token_time').value = '';
        $('u_s_backend_google_access_token').value = '';
        $('u_s_backend_google_token_type').value = '';
        $('u_s_backend_google_expires_in').value = '';
        $('u_s_backend_google_refresh_token').value = '';
        $('u_s_backend_google_phonebooks').value = '';
        $('u_s_backend_google_logout').hide();
        $('u_s_backend_google_login').show();

        this.uSyncDoSave();
    };

    const _onGoogleLoginCallback = (result) => {
        console.log('_onGoogleLoginCallback', result)
        if (!result) {
            // error
            return;
        }

        if (result.error && result.error != '' && result.error_description) {
            if (result.error_description) {
                setError('error', result.error_description);
            } else {
                // unknow
            }
        } else if(result.token && result.userInfo){
            _tryToSync(result);
        }
    };

    const _tryToSync = (data) => {
        ap_showWaitMessage('waitDiv', 1);
        getGoogleAuthUrl('users', (response) => {
            this.syncGoogleAuthUrlAvailable = true;
            this.syncGoogleAuthUrl = response.url;

            new Ajax.Request('aclpbx/index.php', {
                method: 'post',
                parameters: $H({
                    action: 'try_google_domainusers',
                    token: $H(data.token).toJSON(),
                    adminView: data.adminView || 'no',
                }).toQueryString(),
                onComplete: (transport) => {
                    ap_showWaitMessage('waitDiv', 0);
                    if ("responseJSON" in transport && "users" in transport.responseJSON) {
                        var response = transport.responseJSON;

                        if (data.userInfo) {
                            $('u_s_backend_google_mail').value = data.userInfo.email;
                            $('u_s_backend_google_mail_text').innerHTML = data.userInfo.email;
                        }

                        $('u_s_backend_google_received_token_time').value = response.token.received_token_time;
                        $('u_s_backend_google_access_token').value = response.token.access_token;
                        $('u_s_backend_google_token_type').value = response.token.token_type;
                        $('u_s_backend_google_expires_in').value = response.token.expires_in;
                        $('u_s_backend_google_refresh_token').value = response.token.refresh_token;

                        if (data.adminView === 'yes') {
                            $('u_s_backend_google_adminView').checked = true;
                        }

                        $('u_s_backend_google_logout').show();
                        $('u_s_backend_google_login').hide();
                    } else if ("error" in transport.responseJSON && "message" in transport.responseJSON.error) {
                        if (data && data.token && data.token.access_token) {
                            setError('error', transport.responseJSON.error.message);
                        }
                    }
                }
            });
        }, (response) => {
            ap_showWaitMessage('waitDiv', 0);
            setError('error', 'Cannot fetch Google Auth url');
        });
    }

    this.uSyncToggleRecurrentJob = function(el, id1, id2) {
        this.uSyncToggleMapAttr(el,id1);
        this.uSyncToggleMapAttr(el,id2);
    };

    this.uSyncToggleMapAttr = function(el, id){
        $(id)[el.checked? 'enable': 'disable']();
        el.value = el.checked? 1: 0;
    };

    this.usSyncSetFrom = function() {
    var oBackend = $('u_s_backend_backend');
    $H({'ldap':'LDAP','activeD':'Active Directory','domino':'Lotus Domino','mysql':'MySQL','mssql':'MSSQL','office365':'Office365','google':'Google','csv':'CSV','zohoCrm':'Zoho'}).each(function(val){
        oBackend.options[oBackend.options.length] = new Option(val.value,val.key);
    });

    oBackend = $('us_recurrent_interval');
    $H({'1':'1','2':'2','6':'6','12':'12','24':'24'}).each(function(val){
        oBackend.options[oBackend.options.length] = new Option(val.value,val.key);
    });

    this.uSyncCurrBackend = this.usSyncSettingsAndMap['global']['backend'];
    $('u_s_backend_backend').value = this.uSyncCurrBackend;

    $('u_s_global_remove_users').checked = false;
    $('u_s_global_erase_values').checked = false;
    if (this.usSyncSettingsAndMap['global']['remove_users'] == 'yes'){
        $('u_s_global_remove_users').checked = true;
    }
    if (this.usSyncSettingsAndMap['global']['erase_values'] == 'yes'){
        $('u_s_global_erase_values').checked = true;
    }

    var t_filter = '(&(objectCategory=person)(objectClass=user)(!(userAccountControl:1.2.840.113556.1.4.803:=2)))';
    var t_options = new Array(this.usSyncSettingsAndMap['settings']['ldap']['filter']);
    if (this.usSyncSettingsAndMap['settings']['ldap']['filter'] != t_filter) t_options.push(t_filter);
    oBackend = $('u_s_backend_ldap_filter');

    var t_filter = '(&(objectCategory=person)(objectClass=user)(!(userAccountControl:1.2.840.113556.1.4.803:=2)))';
    var t_options = new Array(this.usSyncSettingsAndMap['settings']['activeD']['filter']);
    if (this.usSyncSettingsAndMap['settings']['activeD']['filter'] != t_filter) t_options.push(t_filter);
    oBackend = $('u_s_backend_activeD_filter');
    $A(t_options).each(function(val){
        //oBackend.options[oBackend.options.length] = new Option(val,val);
    });

    t_filter = 'SELECT ${MAP} FROM `users_table` WHERE `type`="local"';
    t_options = new Array(this.usSyncSettingsAndMap['settings']['mysql']['filter']);
    if (this.usSyncSettingsAndMap['settings']['mysql']['filter'] != t_filter) t_options.push(t_filter);
    oBackend = $('u_s_backend_mysql_filter');

    t_filter = 'SELECT ${MAP} FROM [users_table] WHERE [type]=\'local\'';
    t_options = new Array(this.usSyncSettingsAndMap['settings']['mssql']['filter']);
    if (this.usSyncSettingsAndMap['settings']['mssql']['filter'] != t_filter) t_options.push(t_filter);
    oBackend = $('u_s_backend_mssql_filter');


    oBackend = $('u_s_backend_csv_import_mountpoint');
    $H(cSyncMounts).each(function(pair){
        oBackend.options[oBackend.options.length] = new Option(pair.value,pair.key);
    });

    // IE !! rrrr
    $('us_map_cn_on').disabled = true;
    $('us_map_sourceId_on').disabled = true;

    $A(['ldap','activeD','domino','mysql','mssql','office365','google','csv']).each((backend) => {
        this.uSyncPlaceSyncSettings(backend);
    });

    this.uSyncPlaceSyncMap(this.uSyncCurrBackend);
    this.uSyncPlaceSyncRecurrentJob();
    this.uSyncChangeBackend(this.uSyncCurrBackend);
    this.uSyncChangeCsvImportType($F('u_s_backend_csv_import_type'));
};

    this.uSyncPlaceSyncSettings = (backend) => {
    if(backend == 'google' && ('default' in this.usSyncSettingsAndMap) && (backend in this.usSyncSettingsAndMap['default']['settings'])){
        $H(this.usSyncSettingsAndMap['default']['settings'][backend]).each((pair) => {
            if(!this.usSyncSettingsAndMap['settings'][backend]){
                this.usSyncSettingsAndMap['settings'][backend] = {};
            }
            if(!this.usSyncSettingsAndMap['settings'][backend][pair.key]){
                this.usSyncSettingsAndMap['settings'][backend][pair.key] = pair.value;
            }
        });
    }
    $H(this.usSyncSettingsAndMap['settings'][backend]).each((pair) => {
        if($('u_s_backend_'+backend+'_'+pair.key+'').type == 'checkbox'){
            $('u_s_backend_'+backend+'_'+pair.key+'').checked = (pair.value == 'yes');
        }else{
            $('u_s_backend_'+backend+'_'+pair.key+'').value = pair.value;
        }
    });
};

    this.uSyncChangeCsvImportType = function(val) {
        if (val == 'share') {
            $('u_s_backend_csv_import_type_upload').hide();
            $('u_s_backend_csv_import_type_share').show();
        }else{
            $('u_s_backend_csv_import_type_upload').show();
            $('u_s_backend_csv_import_type_share').hide();
        }
    };

    this.uSyncPlaceSyncMap = function(backend){
        // disable all here
        var def = {};
        if(('default' in this.usSyncSettingsAndMap) && (backend in this.usSyncSettingsAndMap['default']['map'])){
            def = this.usSyncSettingsAndMap['default']['map'][backend];
        }

        $A(this.usSyncFields).each(function(val){
            $('us_map_'+val+'').value = def[val] || '';
            $('us_map_'+val+'').disabled = true;
            $('us_map_'+val+'_on').value = '0';
            $('us_map_'+val+'_on').checked = false;
        });
        $H(this.usSyncSettingsAndMap['map'][backend]).each(function(pair){
            $('us_map_'+pair.key+'').value = pair.value;
            $('us_map_'+pair.key+'').disabled = false;
            $('us_map_'+pair.key+'_on').value = '1';
            $('us_map_'+pair.key+'_on').checked = true;
        });

        //leverage for zoho.
        if (backend === 'zohoCrm') {
            $('us_map_sourceId').disabled = true;
        }
    };

    this.uSyncPlaceSyncRecurrentJob = function(){
    if (this.usSyncSettingsAndMap['recurrent_job']['enabled'] == 'yes'){
        $('us_recurrent_on').checked = true;
        $('us_recurrent_on').value = 1;
        $('us_recurrent_interval').disabled = false;
        $('us_recurrent_interval').value = this.usSyncSettingsAndMap['recurrent_job']['interval'];
        $('us_recurrent_email').disabled = false;
        $('us_recurrent_email').value = this.usSyncSettingsAndMap['recurrent_job']['email'];
    }else{
        $('us_recurrent_on').checked = false;
        $('us_recurrent_on').value = 0;
        $('us_recurrent_interval').value = '1';
        $('us_recurrent_interval').disabled = true;
        $('us_recurrent_email').value = '';
        $('us_recurrent_email').disabled = true;
    }
};

    this.uSyncChangeBackend = function(backend){
    // set this.usSyncSettingsAndMap['map'][this.uSyncCurrBackend]
    $A(this.usSyncFields).each((val) => {
        if ($('us_map_'+val+'_on').checked && $F('us_map_'+val) != ''){
            this.usSyncSettingsAndMap['map'][this.uSyncCurrBackend][val] = $F('us_map_'+val+'');
        }else{
            //delete this.usSyncSettingsAndMap['map'][this.uSyncCurrBackend][val];
        }
    });
    this.uSyncCurrBackend = backend;
    $$('#users_sync_backend_settings tr.u_s_backend_ldap').invoke('hide');
    $$('#users_sync_bottom tr.u_s_backend_ldap').invoke('hide');

    $$('#users_sync_backend_settings tr.u_s_backend_activeD').invoke('hide');
    $$('#users_sync_bottom tr.u_s_backend_activeD').invoke('hide');

    $$('#users_sync_backend_settings tr.u_s_backend_domino').invoke('hide');
    $$('#users_sync_bottom tr.u_s_backend_domino').invoke('hide');

    $$('#users_sync_backend_settings tr.u_s_backend_mysql').invoke('hide');
    $$('#users_sync_bottom tr.u_s_backend_mysql').invoke('hide');

    $$('#users_sync_backend_settings tr.u_s_backend_mssql').invoke('hide');
    $$('#users_sync_bottom tr.u_s_backend_mssql').invoke('hide');

    $$('#users_sync_backend_settings tr.u_s_backend_office365').invoke('hide');
    $$('#users_sync_bottom tr.u_s_backend_office365').invoke('hide');
    $$('#users_sync_backend_settings tr.u_s_hint_office365').invoke('hide');

    $$('#users_sync_backend_settings tr.u_s_backend_google').invoke('hide');
    $$('#users_sync_bottom tr.u_s_backend_google').invoke('hide');
    $$('#users_sync_backend_settings tr.u_s_hint_google').invoke('hide');
    $$('#users_sync_backend_settings tr.u_s_hint_zohoCrm').invoke('hide');

    $$('#users_sync_backend_settings tr.u_s_backend_csv').invoke('hide');
    $$('#users_sync_bottom tr.u_s_backend_csv').invoke('hide');

    $$('#users_sync_backend_settings tr.u_s_backend_zohoCrm').invoke('hide');
    $$('#users_sync_bottom tr.u_s_backend_zohoCrm').invoke('hide');

    if(backend == 'csv' && (this.varsPhp.isWcloud || ! $H(cSyncMounts).size())){
        $$('#users_sync_recurrent').invoke('hide');
        $('us_recurrent_on').checked = false;
    }
    else{
        $$('#users_sync_recurrent').invoke('show');
    }

    if(backend == 'office365'){
        var settings = this.usSyncSettingsAndMap['settings'][backend];

        _onOffice365LoadToken({token: {
            'access_token': settings.access_token,
            'expires_in': settings.expires_in,
            'received_token_time': settings.received_token_time,
            'id_token': settings.id_token,
            'id_token_expires_in': settings.id_token_expires_in,
            'refresh_token': settings.refresh_token,
            'token_type': settings.token_type
        },
        userInfo: {
            preferred_username: settings.mail
        }});
    }

    if(backend == 'zohoCrm'){
        var settings = this.usSyncSettingsAndMap['settings'][backend];

        if (settings) {
            _onZohoCrmLoadToken({
                token: {
                    'access_token': settings.access_token,
                    'expires_in': settings.expires_in,
                    'received_token_time': settings.received_token_time,
                    'refresh_token': settings.refresh_token,
                    'token_type': settings.token_type,
                    'api_domain': settings.api_domain,
                    'location': settings.location,
                    'accounts_server': settings.accounts_server
                },
                userInfo: {
                    full_name: settings.full_name
                }
            });
        }
    }

    if (backend == 'google') {
        var settings = this.usSyncSettingsAndMap['settings'][backend] || {};

		    	_tryToSync({token: {
                            'access_token': settings.access_token,
                            'expires_in': settings.expires_in,
                            'received_token_time': settings.received_token_time,
                            'refresh_token': settings.refresh_token,
                            'token_type': settings.token_type
		    			},
                        userInfo: {
                            email: settings.mail
                        },
                        adminView: settings.adminView
                });
		    }

    $$('#users_sync_backend_settings tr.u_s_backend_'+backend).invoke('show');
    $$('#users_sync_backend_settings tr.u_s_hint_'+backend).invoke('show');
    $$('#users_sync_bottom tr.u_s_backend_'+backend).invoke('show');
    this.uSyncPlaceSyncMap(backend);
};

    this.uSyncBack = function(el) {
    this.uSyncUpdater.stop();
    $('users_sync_settings_div').show();
    $('users_sync_log_div').update('&nbsp');
    $('users_sync_log_div').hide();
    $('users_sync_div_buttons_settings').show();
    $('users_sync_div_buttons_test').hide();
};

    this.uSyncDoSave = function() {

        var t_backend = $F('u_s_backend_backend');
        var go_settings = {"global":{"backend":t_backend,"remove_users":"no","erase_values":"no"}};

        if ($('u_s_global_remove_users').checked){
            go_settings['global']['remove_users'] = 'yes';
        }
        if ($('u_s_global_erase_values').checked){
            go_settings['global']['erase_values'] = 'yes';
        }

        $$('span.err_span').invoke('remove');
        // no recurrent job for csv
        if (t_backend == 'csv' && $('us_recurrent_on').checked && $F('u_s_backend_csv_import_type') == 'upload'){
            raiseErrors({'us_recurrent_on':WMS._t('aclpbx.noRecurrentSyncForCsv')});
            return false;
        }
        // check share is present for csv
        if (t_backend == 'csv' && $F('u_s_backend_csv_import_type') == 'share' && ! $F('u_s_backend_csv_import_mountpoint')){
            raiseErrors({'u_s_backend_csv_import_mountpoint':WMS._t('rules.enterValidValue')},' ');
            return false;
        }

        $A(['ldap','activeD','domino','mysql','mssql','office365','google','csv', 'zohoCrm']).each((backend) => {
            go_settings[backend] = this.uSyncReadSettings(backend);
            if (t_backend != backend){
                go_settings[backend]['map'] = this.usSyncSettingsAndMap['map'][backend];
            }
        });

        go_settings['recurrent_job'] = {};
        if ($('us_recurrent_on').checked){
            go_settings['recurrent_job']['enabled'] = 'yes';
            go_settings['recurrent_job']['interval'] = $F('us_recurrent_interval');
            go_settings['recurrent_job']['email'] = $F('us_recurrent_email');
        }else{
            go_settings['recurrent_job']['enabled'] = 'no';
        }

        ap_showWaitMessage('waitDiv', 1);

        return new Ajax.Request('aclpbx/index.php',{
            method: 'post',
            parameters:$H({
                "action": 'users_sync_save',
                "settings": $H(go_settings).toJSON()
            }).toQueryString(),
            onComplete: (transport) => {
                // fixme: may be error(s) in resp?
                this.usSyncSettingsAndMap = transport.responseJSON;
                ap_showWaitMessage('waitDiv', 0);
            }
        });
    },

    this.uSyncReadSettings = function(backend){
		    var t_settings = {'backend': backend};
		    $H(this.usSyncSettingsAndMap['settings'][backend]).each(function(pair){
                if ($('u_s_backend_' + backend + '_' + pair.key + '').type == 'checkbox') {
                    if ($('u_s_backend_' + backend + '_' + pair.key + '').checked) {
                        t_settings[pair.key] = 'yes';
                    } else {
                        t_settings[pair.key] = 'no';
                    }
                } else {
                    t_settings[pair.key] = $F('u_s_backend_' + backend + '_' + pair.key + '');
                }
		    });
		    // get map
		    var t_map = {}
		    $A(this.usSyncFields).each(function(val){
		        if ($('us_map_'+val+'_on').checked && $F('us_map_'+val) != ''){
		            t_map[val] = $F('us_map_'+val+'');
		        }
		    });
		    return {'settings': t_settings, 'map': t_map};
		},

    this.uSyncDoSync = function(dry_run, verbose) {
        var syncid = Math.random().toString().substring(3,8);
        var backend = $F('u_s_backend_backend');
        var go_settings = this.uSyncReadSettings(backend);

        //save setting
        this.uSyncDoSave();
        go_settings['global'] = {"remove_users":"no","erase_values":"no"};
        if ($('u_s_global_remove_users').checked){
            go_settings['global']['remove_users'] = 'yes';
        }
        if ($('u_s_global_erase_values').checked){
            go_settings['global']['erase_values'] = 'yes';
        }

        $$('span.err_span').invoke('remove');
        // check share is present for csv
        if (backend == 'csv' && $F('u_s_backend_csv_import_type') == 'share' && ! $F('u_s_backend_csv_import_mountpoint')){
            raiseErrors({'u_s_backend_csv_import_mountpoint':WMS._t('rules.enterValidValue')},' ');
            return false;
        }

        if (go_settings['settings']['backend'] == 'csv' && $F('u_s_backend_csv_import_type') == 'upload'){
            go_settings['dry_run'] = dry_run;
            go_settings['verbose'] = verbose;
            go_settings['syncid'] = syncid;
            $('u_s_backend_csv_params').name = 'u_s_backend_csv_params';
            $('u_s_backend_csv_params').value = $H(go_settings).toJSON();
            var form = $('users_sync_backend_settings_filter_form');
            var rez = AIM.submit(
                form,
                {
                    'onStart' : this.uSyncUplCsvStartCallback,
                    'onComplete' : (response) => {
                        if(response !== ''){
                            if (response === 'Access denied') {
                                ap_showWaitMessage('waitDiv', 0);
                                raiseErrors({u_s_backend_csv: response}, ' ');
                                return false
                            }

                            const oResponse = eval("(" + response + ")");
                            if(oResponse === true){
                                this.uSyncStartShowLog(syncid);
                            }else if (oResponse.ERRORS){
                                ap_showWaitMessage('waitDiv', 0);
                                raiseErrors({'u_s_backend_csv_fileid':oResponse.ERRORS}, ' ');
                            }else{
                                ap_showWaitMessage('waitDiv', 0);
                                raiseErrors(oResponse,' ');
                            }
                        }else{
                            ap_showWaitMessage('waitDiv', 0);
                            raiseErrors({'u_s_backend_csv_fileid':'Upload error'},' ');
                        }
                    }
                }
            );
            if (!rez){
                return false;
            }else{
                form.submit();
                return true;
            }
        }

        ap_showWaitMessage('waitDiv', 1);
        return new Ajax.Request('aclpbx/index.php',{
            method: 'post',
            parameters:$H({
                "action": 'users_sync',
                "dry_run": dry_run,
                "verbose": verbose,
                "syncid": syncid,
                "settings": $H(go_settings).toJSON()
            }).toQueryString(),
            onComplete: (transport) => {
                this.uSyncStartShowLog(syncid);
            }
        });
    };

    this.uSyncStartShowLog = function(syncid){
        $('users_sync_settings_div').hide();
        $('users_sync_log_div').update('&nbsp');
        $('users_sync_log_div').show();
        $('users_sync_div_buttons_settings').hide();
        $('users_sync_div_buttons_test').show();
        $('us_btn_back').setAttribute('disabled', true);

        ap_showWaitMessage('waitDiv', 0);

        this.uSyncUpdater = new Ajax.PeriodicalUpdater (false/* stop */,'monit/log/?act=show_users_sync&syncid='+syncid, {
            method: 'get', frequency: 2, decay: 1,
            onSuccess: (t) => {
                if (t.status == '200') {
                    if (t.responseText != ''){
                        var t_arr = t.responseText.split("\n");
                        var t_completed = false;
                        for (var t_cnt = 0, t_length = t_arr.length; t_cnt < t_length; t_cnt++){
                            if (t_arr[t_cnt].indexOf('The operation is completed.') != -1 || t_arr[t_cnt].indexOf('No change was provided.') != -1){
                                t_completed = true;
                            }
                        }
                        $('users_sync_log_div').update(t_arr.join("<br /><br />") + (t_completed?"":'<div style="background-color:#233259;color:#d5d5d3;font-size:11px;height:20px;font-weight:bold">'+ WMS._t('strings.Proceeding') + '...</div>'));
                        t_arr = null;
                        if (t_completed){
                            this.getLicenseUsageStatus();
                            this.uSyncUpdater.stop();
                            $('us_btn_back').removeAttribute('disabled');
                            dispatchEvent(new Event('userFormSaved')); // TODO this was added in ticket WMS-15278 instead of the line below
                            // location.reload(); // TODO rewrite to callback as it's done in phonebook tab
                            // this.reloadTable('noClose');
                        }
                    }
                }
            }
        });
    };

    this.uSyncUplCsvStartCallback = function(){
        $$('span.err_span').invoke('remove');
        ok = $A(['u_s_backend_csv_fileid']).inject([],function(a,n){
            if($(n).value != '') a.push($(n).value);
            return a;
        }).all(function(value){
            return ['.csv'].any(function(extension){
                return value.endsWith(extension.toLowerCase());
            });
        });
        if(!ok || $F('u_s_backend_csv_fileid') == ''){
            raiseErrors({'u_s_backend_csv_fileid':'Valid format: csv'},' ');
            ap_showWaitMessage('waitDiv', 0);
            return false;
        } else {
            return true;
        }
    };

    this.showDialog = function(width, height, content, functionOk, buttons, noEnter, functionCancel){
        this.modwin = new UI.Window($H({
            width: width,
            resizable:false,
            height: height,
            shadow: false,
            superflousEffects : false,
            theme: 'bluelighting'
        }).toObject())
        .setContent(content)
        .center({ auto: true })

        if( ! buttons){
            this.modwin.prefoot.innerHTML = '<input id="saveUserButOk" type="button" value="'+(WMS._t('buttons.Ok') || 'Ok')+'" class="but20" />\
            <input id="saveUserButCancel" type="button" value="'+(WMS._t('buttons.Cancel') || 'Cancel')+'" class="but20" />';
        }else{
            this.modwin.prefoot.innerHTML = buttons;
        }

        this.modwin.show(true).focus();

        if(functionOk){
            $('saveUserButOk').onclick = functionOk;
            this.modwin.content.onkeyup = (event) => {
                if(event.keyCode==13 && !noEnter) {
                    functionOk.apply(this);
                }
            };
        }

        if(functionCancel) {
            $('saveUserButCancel').onclick = functionCancel;
        }
        $('saveUserButCancel').onmouseup = () => {
            this.modwin.close();
            this.modwin = null;
        };

        return this.modwin;
    };

    this.showSecondDialog = function(width, height, content, functionOk, buttons, noEnter){
        this.modsecwin = new UI.Window($H({
            width: width,
            resizable:false,
            height: height,
            shadow: false,
            superflousEffects : false,
            theme: 'bluelighting'
        }).toObject())
            .setContent(content)
            .center({ auto: true });

        if( ! buttons){
            this.modsecwin.prefoot.innerHTML = '<input id="pressUserButOk" type="button" value="'+(WMS._t('buttons.Ok') || 'Ok')+'" class="but20" />\
            <input id="pressUserButCancel" type="button" value="'+(WMS._t('buttons.Cancel') || 'Cancel')+'" class="but20" />';
        }else{
            this.modsecwin.prefoot.innerHTML = buttons;
        }

        this.modsecwin.show(true).focus();

        if(functionOk){
            $('pressUserButOk').onclick = functionOk;
            this.modsecwin.content.onkeyup = (event) => {
                if(event.keyCode==13 && !noEnter) {
                    functionOk.apply(this);
                }
            };
        }

        $('pressUserButCancel').onclick = () => {
            this.modsecwin.close();
            this.modsecwin = null;
        };

        return this.modsecwin;
    };

    this.getLicenseUsageStatus = function () {
        new Ajax.Request('aclpbx/index.php',{
            method: 'post',
            parameters:$H({
                "action": 'getLicenseUsageStatus'
            }).toQueryString(),
            onComplete:  (response) => {
                const res = response.responseText;
                if (res !== 'OK') {
                    setError('error', res);
                }
            }
        });
    };

    initialize(data);
};

var raiseErrors = function(oErrors,suffix){
    if (typeof(suffix) == "undefined") suffix = '<br>'
    for(key in oErrors) {
        Element.insert(key,{'before':
            '<span class="err_span" style="color:#ff0000;padding-left:10px">'+oErrors[key]+suffix+'</span>'
        });
    }
}
