if (!window.location.pathname.includes('oauth2')) {
    window.localStorage.setItem("auth", 0);
}

pbxGenerateCodesForSecondFactors = ['email', 'sms'];

$(document).ready(function() {
	$("#user-auth").focus();
	$('.btn-sing-on-google').on('click', loadGoogleSignOnUrl);
	$('.btn-sing-on-office365').on('click', loadOffice365SignOnUrl);
	isRememberAllowed();
	checkCallControlPassed();

	var portalToken = $('#portalToken');
	var portalUserLogin = $('#portalUserLogin');
	if (portalToken.length && portalUserLogin.length) {
		callbackPortalSingleSignOn(portalUserLogin.val(), portalToken.val());
	}
});

function auth(isTwoFactor) {
	isTwoFactor

	var data = {
		remember: +$(".remember-me__field").is(':checked'),
		callControl: isCallControlEnabled(),
        isMsTeams: isMicrosoftTeams(),
	};

	var error = false;

	if(isTwoFactor){
		data['type'] = 'next';
		data['code'] = $(".form-field__code").val();
		if(data['code'] == ''){
			$(".form-field__code").addClass('error');
			error = true;
		}
	}else{
		data['login'] = $("#user-auth").val();
		data['password'] = $("#password-auth").val();

		if(data['login'] == ''){
			$("#user-auth").addClass('error');
			error = true;
		}

		if(data['password'] == ''){
			$("#password-auth").addClass('error');
			error = true;
		}
	}

	if(error){
		return false;
	}

	sendLoginRequest(data);

	return false;
}

function showTwoFactorForm(secondFactor){
	secondFactor = secondFactor.toLowerCase();
    if (pbxGenerateCodesForSecondFactors.indexOf(secondFactor) === -1) {
        $('form.form-two-factor').removeClass('with-timer');
        $('form.form-two-factor .form-two-factor__subtitle').text('To log in, use the confirmation code generated by the mobile application.');
	} else {
    	$('form.form-two-factor').addClass('with-timer');
        $('form.form-two-factor .form-two-factor__subtitle').text('To log in, use the confirmation code sent to you.');

        var CountDown = function(element) {
            this._element = (element instanceof Element) ? $(element) : element;
            this._timer = null;
            this._controlReset = $('<div/>').attr('title', 'Resend authentication code').addClass('controlReset').addClass('fa').addClass('fa-icon_timer');

            this.load = function() {
                this._controlReset.on('click', this._reload.bind(this));
                this._startTimer();
            };

            this._reload = function() {
                if (this._timer === null) {
                    return;
                }

                this._resendAuthenticationCode();

                this._controlReset.detach();
                this._timer.start();
            };

            this._startTimer = function() {
                var self = this;
                var countdownOptions = {
                    radius: 20,
                    seconds: 180,
                    fontColor: '#000000',
					fontWeight: 'normal',
                    strokeStyle: '#3986C2',
                    fillStyle: '#fff',
                    fontSize: 12,
                    strokeWidth: 2,
                    smooth: true,
                    label: false,
                    autostart: false,
                    onComplete: self._showControls.bind(self)
                };

                this._timer = this._element.countdown360(countdownOptions);
                this._timer.start();
            };

            this._showControls = function() {
                this._element.append(this._controlReset);
            };

            this._resendAuthenticationCode = function() {
            	$.post('/api/v1/personal/settings/TwoFactor/' + secondFactor + '/Code/');
			};
        };

        var countdown = new CountDown($('.countdown'));
        countdown.load();
	}

    $('form.form-auth__body').hide();
    $('form.form-two-factor').show();
	$(".form-field__code").focus();
}

function sendLoginRequest(formData){

	$('.form-auth input.error').removeClass('error');

	$('.form-auth .form-wrap').mask('Loading...');

	let isOauthMode = typeof oauth2Mode === 'boolean' && oauth2Mode === true && typeof oauth2GrantUrl === 'string';

	let url = isOauthMode ? '../authorization/oauth2Login' : '../api/v1/personal/login' + (formData.callControl ? '?sip=no' : '');

	$.ajax({
		type: 'POST',
		url: url,
		data: formData,
		success: function(data, textStatus, jqXHR){
			$('.form-error__message').html("");
			if(data && data.type == 'result' ){
				if(data.result == 'OK'){
					if (isOauthMode) {
						window.location = oauth2GrantUrl;
					} else if (isMicrosoftTeams()) {
						window.sessionStorage.setItem('isMsTeams', '1');
						// only for Microsoft Teams - fallback
						window.localStorage.setItem('callControl', Number(formData.callControl));
						setTimeout(() => {
							window.location = '../' + (formData.callControl? '?sip=no' : '');
						}, 100)
					} else {
						let prevLocationRegex = new RegExp(/^\?\//);
						let newLocation	= prevLocationRegex.test(location.search) ? location.search.replace(prevLocationRegex, '../') : '../';

						window.location = newLocation + (formData.callControl ? '?sip=no' : '');
					}
				}else if(data.result['next']){
					$('.form-auth').unmask();
					showTwoFactorForm(data.result['next']);
				}
			}

		},
		error: function(jqXHR, textStatus, errorThrown){
			$('.form-auth .form-wrap').unmask();
			var response = JSON.parse(jqXHR.responseText);
            if (response.type === 'error' && response.reason && response.reason !== '') {
                let errorMessage = response.reason;
                if (response.errors && response.errors.length > 0) {
                    errorMessage = response.errors.join('<br>');
                }

                $('.form-error__message').html(errorMessage);
                $('.form-error__message:visible').parents("form").find(".form-field").addClass("error-field");
            }
		}
	});
}

function isCallControlEnabled() {
	return $('#call-control').is(':checked') || isMicrosoftTeams();
}

function callbackGoogleSingleSignOn(data){
	if(data){
		if(data.error && data.error_description){
			$('.form-error__message').html(data.error_description);
		}else if(data.token && data.userInfo){
			$("#user-auth").val(data.userInfo.email);
			$("#password-auth").val('');

			var login = $("#user-auth").val();

			var error = false;
			if(login == ''){
				$("#user-auth").addClass('error');
				error = true;
			}

			if(error){
				return false;
			}

			sendLoginRequest({
				type: 'google',
				login: login,
				remember: +$(".remember-me__field").is(':checked'),
				callControl: isCallControlEnabled(),
                isMsTeams: isMicrosoftTeams(),
				token: data.token,
			});
		}
	}
}


function callbackMicrosoftSingleSignOn(data){
	if(data){
		if(data.error && data.error_description){
			$('.form-error__message').html(data.error_description);
		}else if(data.token && data.userInfo){
			$("#user-auth").val(data.userInfo.preferred_username);
			$("#password-auth").val('');

			var login = $("#user-auth").val();

			var error = false;
			if(login == ''){
				$("#user-auth").addClass('error');
				error = true;
			}

			if(error){
				return false;
			}

			sendLoginRequest({
				type: 'microsoft',
				login: login,
				remember: +$(".remember-me__field").is(':checked'),
				callControl: isCallControlEnabled(),
                isMsTeams: isMicrosoftTeams(),
				token: data.token,
			});
		}
	}
}

function callbackPortalSingleSignOn(login, token) {
	if (login && token) {
		$("#user-auth").val(login);
		$("#password-auth").val('');

		sendLoginRequest({
			type: 'portal',
			login: login,
			remember: false,
			token: token,
			callControl: isCallControlEnabled(),
            isMsTeams: isMicrosoftTeams(),
		});
	}
}

function loadOffice365SignOnUrl(){
	if (isMicrosoftTeamsNativeApp()) {
		microsoftTeams.authentication.authenticate({
			url: window.location.origin + '/api/Microsoft/SingleSignOn/?callback=callbackMicrosoftSingleSignOn',
			width: 800,
			height: 500,
			successCallback: function (result) {
				$("#user-auth").val(result.currentUser);
				$("#password-auth").val('');
				sendLoginRequest({
					type: 'microsoft',
					login: result.currentUser,
					remember: +$(".remember-me__field").is(':checked'),
					callControl: isCallControlEnabled(),
                    isMsTeams: isMicrosoftTeams(),
					token: result.token
				});
			},
			failureCallback: function (reason) {
				$('.form-error__message').html(reason);
			}
		});
	} else {
		window.open(
			'../api/Microsoft/SingleSignOn/?callback=callbackMicrosoftSingleSignOn',
			"Windows sing on",
			"location=0,status=0,scrollbars=0,width=800,height=500"
		);
	}
}

function loadGoogleSignOnUrl(){
    if (isMicrosoftTeamsNativeApp()) {
        microsoftTeams.authentication.authenticate({
            url: window.location.origin + '/api/Google/SingleSignOn/?callback=callbackGoogleSingleSignOn',
            width: 800,
            height: 500,
            successCallback: function (result) {
                $("#user-auth").val(result.currentUser);
                $("#password-auth").val('');
                sendLoginRequest({
                    type: 'google',
                    login: result.currentUser,
                    remember: +$(".remember-me__field").is(':checked'),
                    callControl: isCallControlEnabled(),
                    isMsTeams: isMicrosoftTeams(),
                    token: result.token
                });
            },
            failureCallback: function (reason) {
                $('.form-error__message').html(reason);
            }
        });
    } else {
        window.open(
            '../api/Google/SingleSignOn/?callback=callbackGoogleSingleSignOn',
            "Google sing on",
            "location=0,status=0,scrollbars=0,width=800,height=500"
        );
    }
}

function isRememberAllowed(){
	if(location.protocol !== 'https:'){
		$('.remember-me__field').attr('disabled', true);
	}
}

function isMicrosoftTeams() {
	if (typeof(microsoftTeams) === 'undefined') {
		return false;
	}
	if (sessionStorage.getItem('isMsTeams') === '1') {
		return true;
	}
	const urlParams = new URLSearchParams(window.location.search);
	return urlParams && urlParams.get('mode') === 'msTeams';
}

function isMicrosoftTeamsNativeApp() {
    return typeof navigator !== 'undefined'
        && navigator.userAgent.indexOf('Teams') !== -1
        && navigator.userAgent.indexOf('Electron') !== -1;
}

function checkCallControlPassed(){
	const callControlInput = $('#call-control');
	if (callControlInput.length === 0) {
		return;
	}

	const url = new URL(window.location.href);
	let hasGetParameter = url.searchParams.has('sip');
	let callControlEnabled = hasGetParameter && url.searchParams.get('sip') === 'no';
	// regular users case: call control feature via GET parameter
	if (callControlEnabled) {
		callControlInput.prop({checked: true});
	}

	// force for Microsoft Teams
	if (isMicrosoftTeams()) {
		callControlInput.prop({checked: true, disabled: true});
	}
}

$(document).ready(function() {

	const classPassShow = "fa-icon-password-show";
	const classPassHide = "fa-icon-password-hide";
	const btnShowPassword = document.querySelector(".btn-show-password");
	const btnShowImage = btnShowPassword.querySelector(".image_password");
	const authPassword = document.querySelector(".form-item_password .form-field__password");

	function showPassword (e) {
		if (authPassword.type === "password") {
			authPassword.type = "text";
			btnShowImage.classList.remove(classPassHide);
			btnShowImage.classList.add(classPassShow);
		} else {
			authPassword.type = "password";
			btnShowImage.classList.add(classPassHide);
			btnShowImage.classList.remove(classPassShow);
		}
	}

	btnShowPassword.addEventListener("click", showPassword);

	$(".authorization form .form-field").on("input", function() {
		if($(".authorization .form-error__message:contains(text)")){
			$('.form-error__message').html("");
			$(".authorization form .form-field").removeClass("error-field");
		}
	});
	if (isMicrosoftTeamsNativeApp()) {
		microsoftTeams.initialize();
	}
});
