<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
    <xsl:output method="html"/>

    <xsl:template match="/root/modules/module_settings/tab">
        <li class="main-menu-col__li">
            <a class="main-menu-col__item tooltip" href="#module_settings_container">
                <div class="main-menu-col__icon">
                    <svg class="icon" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink">
                        <use xlink:href="../css/icons-sprite.svg#icon_settings"/>
                    </svg>
                </div>
                <div class="main-menu-col__title">
                    <xsl:value-of select="/root/trans_texts/menu.Settings" />
                </div>
                <div class="tooltip-text tooltip-bottom">
                    <xsl:value-of select="/root/trans_texts/menu.Settings" />
                </div>
            </a>
        </li>
    </xsl:template>


    <xsl:template match="/root/modules/module_settings">
        <div id="module_settings_user_options" class="hidden_block"><xsl:value-of select="/root/modules/module_settings/user_options" /></div>
        <div id="module_settings_container" class="__hidden_block">
            <div class="settings_container_nav_wrapper">
                <xsl:if test="/root/modules/module_settings/@personal_info_acl_enabled ='1'">
                    <div class="user_settings_menu_element" id="user_settings_personal_info"><span><xsl:value-of select="/root/trans_texts/user.EditUser" /></span></div>
                </xsl:if>

                <div class="user_settings_menu_element" id="user_settings_user_features"><span><xsl:value-of select="/root/trans_texts/menu.Features" /></span></div>

                <xsl:if test="/root/modules/module_settings/@function_keys_acl_enabled ='1'">
                    <div class="user_settings_menu_element" id="user_settings_phone"><span><xsl:value-of select="/root/trans_texts/menu.settings.FunctionKeys" /></span></div>
                </xsl:if>
                <div class="user_settings_menu_element" id="user_settings_faxcover">
                    <xsl:choose>
                        <xsl:when test="/root/modules/module_settings/@fax_license_enabled != '1'">
                            <xsl:attribute name="style">display:none;</xsl:attribute>
                        </xsl:when>
                        <xsl:when test="/root/modules/module_settings/@fax_acl_enabled != '1'">
                            <xsl:attribute name="style">display:none;</xsl:attribute>
                        </xsl:when>
                        <xsl:when test="/root/modules/module_settings/@fax_server_acl_enabled != '1'">
                            <xsl:attribute name="style">display:none;</xsl:attribute>
                        </xsl:when>
                    </xsl:choose>
                    <span><xsl:value-of select="/root/trans_texts/fax.FaxcoverOptions" /></span>
                </div>

                <div class="user_settings_menu_element" id="user_settings_defstatus"><span><xsl:value-of select="/root/trans_texts/menu.Defstatus" /></span></div>

                <xsl:if test="/root/modules/module_settings/@callgroups_settings_enabled='1'">
                    <div class="user_settings_menu_element" id="user_settings_callgroups"><span><xsl:value-of select="/root/trans_texts/menu.callgroups" /></span></div>
                </xsl:if>

                <xsl:if test="/root/modules/module_settings/@webrtc_zero_distance_settings_enabled='1'">
                    <div class="user_settings_menu_element" id="user_settings_webrtc_zero_distance" style="display: none;"><span><xsl:value-of select="/root/trans_texts/settings.zero_distance_embedded_extension" /></span></div>
                </xsl:if>
                <xsl:if test="/root/modules/module_calendar/@enabled != '1'">
                    <div class="user_settings_menu_element" id="user_settings_calendar"><span>Outlook</span></div>
                </xsl:if>
                <xsl:if test="/root/modules/module_calendar/@enabled = '1'">
                    <div class="user_settings_menu_element" id="user_settings_calendar_cloud"><span>Microsoft365</span></div>
                </xsl:if>
                <xsl:if test="/root/modules/module_settings/@see_extensions='1'">
                <div class="user_settings_menu_element" id="user_settings_extensions"><span><xsl:value-of select="/root/trans_texts/settings.extensions" /></span></div>
                </xsl:if>
                <div style="clear:both"></div>
            </div>
            <div class="settings_container_content_wrapper">
                <div class="user_settings_content" id="user_settings_personal_info_content"><xsl:apply-templates select="/root/modules/module_settings/edit_user_block"/></div>
                <div class="user_settings_content" id="user_settings_user_features_content"><xsl:apply-templates select="features"/></div>
                <div class="user_settings_content" id="user_settings_phone_content"><xsl:apply-templates select="/root/modules/module_settings/phone"/></div>
                <div class="user_settings_content" id="user_settings_faxcover_content"><xsl:apply-templates select="faxcover_options"/></div>
                <div class="user_settings_content" id="user_settings_webrtc_zero_distance_content"><xsl:apply-templates select="/root/modules/module_settings/webrtc_zero_distance"/></div>
                <div class="user_settings_content" id="user_settings_calendar_content"><xsl:apply-templates select="/root/modules/module_calendar/calendar_settings"/></div>


                <xsl:if test="/root/modules/module_calendar/@enabled = '1'">
                    <div class="user_settings_content" id="user_settings_calendar_cloud_content"><xsl:apply-templates select="/root/modules/module_calendar/calendar_cloud_settings"/></div>
                </xsl:if>
                <div class="user_settings_content" id="user_settings_defstatus_content"><xsl:apply-templates select="defstatus"/></div>
                <div class="user_settings_content" id="user_settings_callgroups_content"><xsl:apply-templates select="callgroups"/></div>
                <xsl:if test="/root/modules/module_settings/@see_extensions='1'">
                <div class="user_settings_content" id="user_settings_extensions_content"><xsl:apply-templates select="extensions"/></div>
                </xsl:if>
            </div>
        </div>

    </xsl:template>

    <xsl:template match="/root/modules/module_settings/edit_user_block">
        <xsl:if test="/root/modules/module_settings/@personal_info_acl_enabled=true">
            <xsl:attribute name="style">display:none;</xsl:attribute>
        </xsl:if>
        <table border="0" width="100%">
            <xsl:if test="/root/modules/module_settings/@password_edit_enabled=1">
            <tr>
                <td class="labels"><xsl:value-of select="/root/trans_texts/user.Password" /></td>
                <td>
                    <button id="change_pass_btn" class="cti_md cti_md_bt_ico" title="Edit">
                        <xsl:attribute name="title"><xsl:value-of select="/root/trans_texts/buttons.Edit" /></xsl:attribute>
                        <i class="fa fa-pencil" aria-hidden="true"></i>
                    </button>
                </td>
            </tr>
            </xsl:if>
            <tr>
                <td class="labels"><xsl:value-of select="/root/trans_texts/user.TwoFactor" /></td>
                <td><label class="twoFactorEditAppName"></label>
                    <button class="twoFactorEdit cti_md cti_md_bt_ico" title="Edit">
                        <xsl:attribute name="title"><xsl:value-of select="/root/trans_texts/buttons.Edit" /></xsl:attribute>
                        <i class="fa fa-pencil" aria-hidden="true"></i>
                    </button>
                    <button class="twoFactorRemove cti_md cti_md_bt_ico" style="display: none" title="Remove">
                        <xsl:attribute name="title"><xsl:value-of select="/root/trans_texts/roster.menu.Remove" /></xsl:attribute>
                    	<i class="fa fa-times" aria-hidden="true"></i>
                    </button>
                </td>
            </tr>
            <tr style="display: none">
                <td class="labels">Web Push</td>
                <td>
                    <input type="checkbox" class="cti_md cti_md_switch" id="webpush" />
                </td>
            </tr>
            <tr>
                <td class="labels" nowrap="1"><xsl:value-of select="/root/trans_texts/main.EMail" /></td>
                <td width="100%">
                    <input class="cti_md" type="text" name="email" id="user_settings_email" size="45" maxlength="50" value=""  style="width: 300px"/>
                </td>
            </tr>

            <tr>
                <td class="labels" nowrap="1"><xsl:value-of select="/root/trans_texts/main.MobileNumber" /></td>
                <td width="100%">
                    <input class="cti_md" type="text" name="mobile" id="user_settings_mobile" maxlength="19" size="45" value=""  style="width: 300px"/>
                </td>
            </tr>

            <tr style='display:none'>
                <td class="labels" nowrap="1"><xsl:value-of select="/root/trans_texts/main.Fax" /></td>
                <td width="100%">
                    <input class="cti_md" type="text" name="fax" id="user_settings_fax" maxlength="20" size="45" value=""  style="width: 300px"/>
                </td>
            </tr>

            <tr>
                <td class="labels" nowrap="1"><xsl:value-of select="/root/trans_texts/user.SelectLang" /></td><td width="100%">
                    <select id="user_settings_pref_lang" name="pref_lang"  class="cti_md">;
                        <option value='en' selected='yes'><xsl:value-of select="/root/trans_texts/main.lang_en" /></option>
                        <option value='it'><xsl:value-of select="/root/trans_texts/main.lang_it" /></option>
                        <option value='de'><xsl:value-of select="/root/trans_texts/main.lang_de" /></option>
                        <option value='fr'><xsl:value-of select="/root/trans_texts/main.lang_fr" /></option>
                        <option value='bg'><xsl:value-of select="/root/trans_texts/main.lang_bg" /></option>
                        <option value='es'><xsl:value-of select="/root/trans_texts/main.lang_es" /></option>
                        <option value='ca'><xsl:value-of select="/root/trans_texts/main.lang_ca" /></option>
                        <option value='es-us'><xsl:value-of select="/root/trans_texts/main.lang_es-us" /></option>
                        <option value='nl'><xsl:value-of select="/root/trans_texts/main.lang_nl" /></option>
                        <option value='en-us'><xsl:value-of select="/root/trans_texts/main.lang_en-us" /></option>
                        <option value='ee'><xsl:value-of select="/root/trans_texts/main.lang_ee" /></option>
                        <option value='fi'><xsl:value-of select="/root/trans_texts/main.lang_fi" /></option>
                        <option value='se'><xsl:value-of select="/root/trans_texts/main.lang_se" /></option>
                        <option value='no'><xsl:value-of select="/root/trans_texts/main.lang_no" /></option>
                        <option value='da'><xsl:value-of select="/root/trans_texts/main.lang_da" /></option>
                        <option value='eu'><xsl:value-of select="/root/trans_texts/main.lang_eu" /></option>
                        <option value='pt'><xsl:value-of select="/root/trans_texts/main.lang_pt" /></option>
                   </select>
               </td>
           </tr>
            <xsl:if test="/root/@ipad != '1'">
               <tr>
                <td class="labels" nowrap="1" valign="center"><xsl:value-of select="/root/trans_texts/settings.avatar_editor.LabelAvatar" /></td>
                <td width="100%">
                    <a style="text-decoration: underline;" href="javascript:void(0)" id="user_settings_image_edit_btn">
                        <xsl:value-of select="/root/trans_texts/buttons.Edit" />
                    </a>
                </td>
            </tr>
            </xsl:if>
            <tr>
                <td class="labels" nowrap="1"><xsl:value-of select="/root/trans_texts/user.SelectDateFormat" /></td><td width="100%">
                <select id="user_settings_date_format" name="DATEFORMAT" rel="DATEFORMAT"  class="cti_md">
                    <option value='d/m/Y' selected='yes'>dd/mm/yyyy</option>
                    <option value='m/d/Y'>mm/dd/yyyy</option>
                    <option value='d M Y'>dd mmm yyyy</option>
                    <option value='M d Y'>mmm dd yyyy</option>
                    <option value='d-m-Y'>dd-mm-yyyy</option>
                    <option value='m-d-Y'>mm-dd-yyyy</option>
                    <option value='Y-m-d'>yyyy-mm-dd</option>
                    <option value='d.m.Y'>dd.mm.yyyy</option>
                </select>

                <select id="user_settings_is_24_hour" name="IS24HOUR" rel="IS24HOUR"  class="cti_md">
                    <option value='1' selected='yes'><xsl:value-of select="/root/trans_texts/user.SelectDateTimeFormat24Hour" /></option>
                    <option value='0'><xsl:value-of select="/root/trans_texts/user.SelectDateTimeFormatAmPm" /></option>
                </select>
                <span id="user_settings_date_format_example"></span>
            </td>
            </tr>
            <xsl:if test="/root/modules/module_settings/@can_set_ring_only_active_device = '1'">
                <tr>
                    <td class="labels" nowrap="1" valign="top"><label for="ring_only_active_device"><xsl:value-of select="/root/trans_texts/user.ROAD" /></label></td>
                    <td width="100%">
                        <input class="cti_md cti_md_switch" type="checkbox" id="ring_only_active_device"/>
                    </td>
                </tr>
            </xsl:if>
            <tr>
                <td class="labels" nowrap="1" valign="top">
                    <label for="dark_mode">
                        <xsl:value-of select="/root/trans_texts/string.dark_theme" />
                    </label>
                </td>
                <td width="100%">
                    <input class="cti_md cti_md_switch" type="checkbox" onclick="" id="dark_mode"/>
                </td>
            </tr>
            <tr>
                <td class="labels" nowrap="1" valign="top" style="padding-top: 8px;"><xsl:value-of select="/root/trans_texts/settings.features.POPUPURL" /></td>
                <td width="100%">
                    <input class="cti_md" type="text" name="POPUPURL" rel="POPUPURL" style='width:600px;' />
                    <button class="cti_md cti_md_bt_ico"><i class="fa fa-question" aria-hidden="true"></i></button>
                    <div>
                    	<table>
                    	<tr>
                    		<td>
                    			<label for="open_popup_incoming_calls_when"><xsl:value-of select="/root/trans_texts/calls.IncomingCall" /></label>
							</td>
                    		<td>
	                    		<select id="open_popup_incoming_calls_when" class="cti_md">
			                        <option value="click" selected="selected"><xsl:value-of select="/root/trans_texts/strings.OnClick" /></option>
			                        <option value="ring"><xsl:value-of select="/root/trans_texts/main.ringing" /></option>
			                        <option value="up"><xsl:value-of select="/root/trans_texts/calls.Answer" /></option>
			                    </select>
                    		</td>
                    	</tr>
                    	<tr>
                    		<td>
                    			<label for="open_popup_outgoing_calls_when"><xsl:value-of select="/root/trans_texts/calls.OutgoingCall" /></label>
	                    	</td>
                    		<td>
	                    		<select id="open_popup_outgoing_calls_when" class="cti_md">
			                        <option value="click" selected="selected"><xsl:value-of select="/root/trans_texts/strings.OnClick" /></option>
			                        <option value="ring"><xsl:value-of select="/root/trans_texts/strings.CallGenerated" /></option>
			                        <option value="up"><xsl:value-of select="/root/trans_texts/calls.Answer" /></option>
			                    </select>
                    		</td>
                    	</tr>
                    	</table>
                    </div>
                    <div style='display:none; width:600px; font-size: 10px;color: #555;padding: 2px 9px;' class="popupurl_info"></div>
                </td>
            </tr>
            <tr style="display: none;" class="hotkeyparam">
                <td class="labels" nowrap="1" valign="top" style="padding-top: 8px;"><xsl:value-of select="/root/trans_texts/settings.features.DialingHotKey" /></td>
                <td width="100%">
                    <input class="cti_md" type="text" name="callHotKey" rel="call" />
                </td>
            </tr>
            <tr style="display: none;" class="hotkeyparam">
                <td class="labels" nowrap="1" valign="top" style="padding-top: 8px;"><xsl:value-of select="/root/trans_texts/settings.features.attendantConsoleHotKey" /></td>
                <td width="100%">
                    <input class="cti_md" type="text" name="attendantConsoleHotKey" rel="attendantconsole" />
                </td>
            </tr>
            <tr>
                <td class="labels" nowrap="1" valign="top" style="padding-top: 8px;"><xsl:value-of select="/root/trans_texts/main.WebApp" /></td>
                <td width="100%">
                    <input class="cti_md" type="text" name="WEBAPP" rel="WEBAPP" style='width:600px;' />
                </td>
            </tr>
       </table>
        <div style="clear:both" />
        <div style="margin-top:30px;">
            <div align="left" class="buttonbox">
                <button id="user_settings_save_user_config" type="button" class="cti_md cti_md_bt inverse"><xsl:value-of select="/root/trans_texts/buttons.Save" /></button>
            </div>
        </div>
    </xsl:template>


    <xsl:template match="/root/modules/module_settings/features">
        <xsl:choose>
            <xsl:when test="/root/@users_share_available = 1">
                <script>var currentUserId=<xsl:value-of select="/root/modules/module_settings/texts/user_uid" />;</script>
                <script id="features_template" type="text/x-jquery-tmpl">
                    <![CDATA[
                        <table class="form">
                            <tbody>
                            <tr>
                                <td class="label">
                                	<label>${$item._t('_ACTIVATED')}</label>
                                </td>
                                {{each $item.getSub()}}
                                <td class="settings" rel="${$value}">
                                	<input class="cti_md cti_md_chbox" type="checkbox" id="features-${$item.currentId}-${$value}-ACTIVATED" name="__ACTIVATED" ${$item.getChecked($value, '_ACTIVATED')} /> <label for="features-${$item.currentId}-${$value}-ACTIVATED">${$item._t($value)}</label>
                                </td>
                                {{/each}}
                            </tr>
                            <!--<tr class="features]]><xsl:if test="/root/modules/module_settings/@do_not_disturb_acl_enabled != '1'"><![CDATA[ hidden ]]></xsl:if><![CDATA[">
                                <td class="label">
                                	<label>${$item._t('DND')}</label>
                                </td>
                                {{each $item.getSub()}}
                                <td class="settings" rel="${$value}">
                                	<input type="checkbox" name="_DND" ${$item.getChecked($value, 'DND')} />
                                </td>
                                {{/each}}
                            </tr>-->
                            <!--<tr class="features]]><xsl:if test="/root/modules/module_settings/@do_not_disturb_acl_enabled != '1'"><![CDATA[ hidden ]]></xsl:if><![CDATA[">
                                <td class="label">
                                	<label>${$item._t('DND_Silent')}</label>
								</td>
								{{each $item.getSub()}}
                                <td class="settings" rel="${$value}">
                                	<input type="radio" name="${$item.currentId}__DND_SILENT" rel="__DND_SILENT" value="silent" ${$item.getChecked($value, 'DND_SILENT')} />
									<input type="hidden" rel="DND_SILENT" name="__DND_SILENT" value="silent">
                                </td>
                                {{/each}}
                            </tr>-->
                            <!--<tr class="features]]><xsl:if test="/root/modules/module_settings/@do_not_disturb_acl_enabled != '1'"><![CDATA[ hidden ]]></xsl:if><![CDATA[">
                                <td class="label">
                                	<label>${$item._t('DND_Reject')}</label>
                                </td>
                                {{each $item.getSub()}}
                                <td class="settings" rel="${$value}">
                                	<input type="radio" name="${$item.currentId}__DND_SILENT" rel="__DND_REJECT" value="reject" ${$item.getChecked($value, 'DND_REJECT')} />
                                	<input type="hidden" rel="DND_REJECT" name="__DND_REJECT" value="reject">
                                </td>
                                {{/each}}
                            </tr>-->
                            <tr class="features]]><xsl:if test="/root/modules/module_settings/@call_waiting_acl_enabled != '1'"><![CDATA[ hidden ]]></xsl:if><![CDATA[">
                                <td class="label">
                                	<label>${$item._t('REJECT')}</label>
								</td>
								{{each $item.getSub()}}
                                <td class="settings" rel="${$value}">
                                	<input class="cti_md cti_md_switch" type="checkbox" name="_REJECT" ${$item.getChecked($value, 'REJECT')} />
                                </td>
                                {{/each}}
                            </tr>
                            <tr class="features]]><xsl:if test="/root/modules/module_settings/@busy_call_forward_acl_enabled != '1'"><![CDATA[ hidden ]]></xsl:if><![CDATA[">
                                <td class="label">
                                	<label>${$item._t('BCF')}</label>
                                </td>
                                {{each $item.getSub()}}
					            <td class="settings" rel="${$value}">
                                	<input class="cti_md cti_md_switch" type="checkbox" name="_BCF" ${$item.getChecked($value, 'BCF')} />
                                	<input class="cti_md" type="text" value="${$item.getValue($value, 'BCF')}" name="BCF" maxlength="" size="" />
									<label class="error fa-stack fa-lg" title="]]><xsl:value-of select="/root/trans_texts/settings.strings.ErrorNoValidValueCanUseLettersNumbers" /> <![CDATA[">
									  	<i class="fa fa-circle fa-stack-2x"></i>
										<i class="fa fa-info fa-stack-1x fa-inverse"></i>
									</label>
								</td>
					            {{/each}}
                            </tr>
                            <tr class="features]]><xsl:if test="/root/modules/module_settings/@unavailable_call_forward_acl_enabled != '1'"><![CDATA[ hidden ]]></xsl:if><![CDATA[">
                                <td class="label">
                                	<label>${$item._t('UCF')}</label>
								</td>
								{{each $item.getSub()}}
                                <td class="settings" rel="${$value}">
                                	<input class="cti_md cti_md_switch" type="checkbox" name="_UCF" ${$item.getChecked($value, 'UCF')} />
                                	<input class="cti_md" type="text" value="${$item.getValue($value, 'UCF')}" name="UCF" maxlength="" size=""/>
									<label class="error fa-stack fa-lg" title="]]><xsl:value-of select="/root/trans_texts/settings.strings.ErrorNoValidValueCanUseLettersNumbers" /> <![CDATA[">
									  	<i class="fa fa-circle fa-stack-2x"></i>
										<i class="fa fa-info fa-stack-1x fa-inverse"></i>
									</label>
								</td>
								{{/each}}
                            </tr>
                            <tr class="features]]><xsl:if test="/root/modules/module_settings/@force_call_forward_acl_enabled != '1'"><![CDATA[ hidden ]]></xsl:if><![CDATA[">
                                <td class="label">
                                	<label>${$item._t('FCF')}</label>
								</td>
								{{each $item.getSub()}}
                                <td class="settings" rel="${$value}">
                                	<input class="cti_md cti_md_switch" type="checkbox" name="_FCF" ${$item.getChecked($value, 'FCF')} />
                                	<input class="cti_md" type="text" value="${$item.getValue($value, 'FCF')}" name="FCF" maxlength="" size="" />
									<label class="error fa-stack fa-lg" title="]]><xsl:value-of select="/root/trans_texts/settings.strings.ErrorNoValidValueCanUseLettersNumbers" /> <![CDATA[">
									  	<i class="fa fa-circle fa-stack-2x"></i>
										<i class="fa fa-info fa-stack-1x fa-inverse"></i>
									</label>
								</td>
								{{/each}}
                            </tr>
                            <tr class="features]]><xsl:if test="/root/modules/module_settings/@call_waiting_acl_enabled != '1'"><![CDATA[ hidden ]]></xsl:if><![CDATA[">
                                <td class="label">
                                	<label>${$item._t('CW')}</label>
								</td>
								{{each $item.getSub()}}
                                <td class="settings" rel="${$value}">
                                	<input class="cti_md cti_md_switch" type="checkbox" name="_CW" ${$item.getChecked($value, 'CW')} />
                                </td>
                                {{/each}}
                            </tr>
                            <tr class="features]]><xsl:if test="/root/modules/module_settings/@dial_timeout_acl_enabled != '1'"><![CDATA[ hidden ]]></xsl:if><![CDATA[">
                                <td class="label">
                                	<label>${$item._t('TOUT')}</label>
								</td>
								{{each $item.getSub()}}
                                <td class="settings" rel="${$value}">
                                	<input class="cti_md cti_md_switch" type="checkbox" name="_TOUT" ${$item.getChecked($value, 'TOUT')} />
                                	<input class="cti_md" type="text" value="${$item.getValue($value, 'TOUT')}" name="TOUT" maxlength="" size="" />
									<label class="error fa-stack fa-lg" title="]]><xsl:value-of select="/root/trans_texts/settings.strings.ErrorNoValidValueCanUseNumbers" /> &lt;= 600<![CDATA[">
									  	<i class="fa fa-circle fa-stack-2x"></i>
										<i class="fa fa-info fa-stack-1x fa-inverse"></i>
									</label>
								</td>
								{{/each}}
                            </tr>
                            <tr class="features]]><xsl:if test="/root/modules/module_settings/@enable_mobility_with_timeout_acl_enabled != '1'"><![CDATA[ hidden ]]></xsl:if><![CDATA[">
                                <td class="label">
                                	<label>${$item._t('MEXT')}</label>
								</td>
								{{each $item.getSub()}}
                                <td class="settings" rel="${$value}">
                                	<input class="cti_md cti_md_switch" type="checkbox" name="_MEXT" ${$item.getChecked($value, 'MEXT')} />
                                	<input class="cti_md" type="text" value="${$item.getValue($value, 'MEXT')}" name="MEXT" maxlength="" size="" />
                                	<label class="error fa-stack fa-lg" title="]]><xsl:value-of select="/root/trans_texts/settings.strings.ErrorNoValidValueCanUseNumbers" />  &lt;= 60 <![CDATA[">
									  	<i class="fa fa-circle fa-stack-2x"></i>
										<i class="fa fa-info fa-stack-1x fa-inverse"></i>
									</label>
								</td>
								{{/each}}
                            </tr>
                            <tr class="features]]><xsl:if test="/root/modules/module_settings/@mobility_confirmation_acl_enabled != '1'"><![CDATA[ hidden ]]></xsl:if><![CDATA[">
                                <td class="label">
                                	<label>${$item._t('MOBCONFIRMATION')}</label>
                                </td>
                                {{each $item.getSub()}}
                                <td class="settings" rel="${$value}">
                                	<input class="cti_md cti_md_switch" type="checkbox" name="_MOBCONFIRMATION" ${$item.getChecked($value, 'MOBCONFIRMATION')} />
                                </td>
                                {{/each}}
                            </tr>
                            <tr class="features]]><xsl:if test="/root/modules/module_settings/@notify_missed_calls_via_email_acl_enabled != '1'"><![CDATA[ hidden ]]></xsl:if><![CDATA[">
                                <td class="label">
                                	<label>${$item._t('EMAILMCN')} </label>
                                </td>
                                {{each $item.getSub()}}
                                <td class="settings" rel="${$value}">
                                	<input class="cti_md cti_md_switch" type="checkbox" name="_EMAILMCN" ${$item.getChecked($value, 'EMAILMCN')} />
                                </td>
                                {{/each}}
                            </tr>
                            <tr class="features]]><xsl:if test="/root/modules/module_settings/@notify_missed_calls_via_sms_acl_enabled != '1'"><![CDATA[ hidden ]]></xsl:if><![CDATA[">
                                <td class="label">
                                	<label>${$item._t('SMSMCN')}</label>
                                </td>
                                {{each $item.getSub()}}
                                <td class="settings" rel="${$value}">
                                	<input class="cti_md cti_md_switch" type="checkbox" name="_SMSMCN" ${$item.getChecked($value, 'SMSMCN')} />
                                </td>
                                {{/each}}
                            </tr>
                            <tr class="features]]><xsl:if test="/root/modules/module_settings/@custom_ringtone_acl_enabled != '1'"><![CDATA[ hidden ]]></xsl:if><![CDATA[">
                                <td class="label">
                                	<label>${$item._t('RING')}</label>
								</td>
								{{each $item.getSub()}}
                                <td class="settings" rel="${$value}">
                                	<input class="cti_md cti_md_switch" type="checkbox" name="_RING" ${$item.getChecked($value, 'RING')} />
                                    <select class="cti_md cti_md" type="text" data-value="${$item.getValue($value, 'RING')}" name="RING" style="width: 150px;"></select>
                                    <button class="cti_md cti_md_bt_ico" title="${$item.play_text}">
                                    	<i class="play fa fa-play"></i>
                                    </button>
                               </td>
                               {{/each}}
                            </tr>
                            </tbody>
                        </table>
                    ]]>
                </script>

                <div id="phoneFeaturesSettingsTabs"><ul></ul></div>
                <br /><button class="cti_md cti_md_bt inverse" rel="saveAllSettings"><xsl:value-of select="/root/trans_texts/buttons.Save" /></button>
                <iframe width="0" height="0" id="download_keyset" src="about:blank" style="display:none"></iframe>
            </xsl:when>
            <xsl:otherwise>
                <xsl:value-of select="/root/trans_texts/main.users_share_not_available" />
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>

    <xsl:template match="/root/modules/module_settings/phone">

        <div id="phoneSettings">
            <xsl:if test="/root/modules/module_settings/@function_keys_acl_enabled != '1'">
                <xsl:attribute name="style">display:none;</xsl:attribute>
            </xsl:if>
	        <input type="hidden" name="FKEYS" rel="FKEYS"/>
	        <div class="hidden" rel="FKEYS_ACL_DISABLED">
	        	<xsl:if test="/root/modules/module_settings/@timetable_acl_enabled != '1'">STIME,</xsl:if>
	        	<xsl:if test="/root/modules/module_settings/@state_3_switch_acl_enabled != '1'">3SWITCH,</xsl:if>
	        	<xsl:if test="/root/modules/module_settings/@switch_acl_enabled != '1'">SWITCH,</xsl:if>
                <xsl:if test="/root/modules/module_settings/@use_and_see_voicemail_acl_enabled != '1'">VM,</xsl:if>
	       	</div>
	        <div id="phoneFunctionKeysList"></div>
    	</div>
    	<br /><button class="cti_md cti_md_bt inverse" rel="saveAllSettings"><xsl:value-of select="/root/trans_texts/buttons.Save" /></button>
    </xsl:template>

    <xsl:template match="/root/modules/module_settings/faxcover_options">
        <div>
            <xsl:choose>
                <xsl:when test="/root/modules/module_settings/@fax_license_enabled != '1'">
                    <xsl:attribute name="style">display:none;</xsl:attribute>
                </xsl:when>
                <xsl:when test="/root/modules/module_settings/@fax_acl_enabled != '1'">
                    <xsl:attribute name="style">display:none;</xsl:attribute>
                </xsl:when>
            </xsl:choose>
        <div id="faxcover_image_status" class="hidden_block"><xsl:value-of select="/root/modules/module_fax/fax_faxcover_status" /></div>
        <div id="faxcover_image_url" class="hidden_block"><xsl:value-of select="/root/modules/module_fax/fax_faxcover_url" /></div>

        <table border="0" width="100%">
            <tr>
                <td valign="top" class="labels" nowrap="1"><label for="send_fax_faxcover_fromfile"><xsl:value-of select="/root/trans_texts/fax.FaxcoverImage" /></label></td>
                <xsl:choose>
                    <xsl:when test="/root/modules/module_settings/@fax_share_enabled = '1'">
                        <td valign="top" width="100%">
                            <div id="send_fax_faxcover_uploader"></div>
                            <div style="width:250px; clear: both;">
                                <xsl:value-of select="/root/trans_texts/fax.FaxCoverDescription" />
                                <div class="upload_files_ipad_disabled hidden_block"><xsl:value-of select="/root/trans_texts/fax.upload_files_disabled_ios" /></div>
                            </div>
                        </td>
                    </xsl:when>
                    <xsl:otherwise>
                        <td valign="top" width="100%">
                            <div style="width:250px;"><xsl:value-of select="/root/trans_texts/fax.FaxCoverImageDisabled" /></div>
                        </td>
                    </xsl:otherwise>
                </xsl:choose>
                <td rowspan="10" valign="center" align="center">
                    <xsl:if test="/root/modules/module_settings/@fax_share_enabled = '1'">
                        <input id="fax_cover_remove_image" type="button" class="cti_md cti_md_bt" value="{/root/trans_texts/roster.menu.Remove}" />
                        <div id="send_fax_faxcover_image"></div>
                    </xsl:if>
                </td>
            </tr>
            <tr>
                <td valign="middle" class="labels" nowrap="1"><xsl:value-of select="/root/trans_texts/faxcover.Company" /></td>
                <td width="100%" valign="top">
                    <input type="text" class="faxcover_input cti_md" id="fax_options_from_company" name="from_company" size="32" maxlength="20" value="" style="width:150px;"/>
                </td>
            </tr>
            <tr>
                <td valign="middle" class="labels" nowrap="1"><xsl:value-of select="/root/trans_texts/fax.LOCALSTATIONID" /></td>
                <td width="100%" valign="top">
                    <input type="text" class="faxcover_input cti_md" id="fax_options_stationid" name="stationid" size="32" maxlength="20" value="" style="width:150px;"/>
                </td>
            </tr>
            <tr>
                <td valign="middle" class="labels" nowrap="1"><xsl:value-of select="/root/trans_texts/fax.LOCALHEADERINFO" /></td>
                <td width="100%" valign="top">
                    <input type="text" class="faxcover_input cti_md" id="fax_options_headerinfo" name="headerinfo" size="32" maxlength="20" value=""  style="width:150px;"/>
                </td>
            </tr>
        </table>

        <div style="clear:both" />
        <div style="margin-top: 30px; width: 650px;">
            <div align="left" class="buttonbox">
                <button id="user_settings_save_faxcover" class="cti_md cti_md_bt inverse" type="button"><xsl:value-of select="/root/trans_texts/buttons.Save" /></button>
            </div>
        </div>
    </div>
    </xsl:template>

    <xsl:template match="/root/modules/module_settings/extensions">
        <table border="0" width="650" id="extensions-list">
            <tr id="no-extensions"><td><xsl:value-of select="/root/trans_texts/extensions.not_available" /></td></tr>
        </table>
    </xsl:template>

    <xsl:template match="/root/modules/module_settings/defstatus">
        <table border="0" width="650">
            <xsl:if test="/root/@chatAllow = '1'">
            <tr>
                <td class="labels" nowrap="1" valign="top"><label for="unread_messages_via_email"><xsl:value-of select="/root/trans_texts/user.UnreadMessagesViaEmail" /></label></td>
                <td width="100%">
                    <input class="cti_md cti_md_switch" type="checkbox" id="unread_messages_via_email"></input>
                </td>
            </tr>
            </xsl:if>
            <tr>
                <td class="labels" style="padding-top: 13px;" nowrap="1" valign="top"><label for="show_notifications_in_dnd"><xsl:value-of select="/root/trans_texts/user.ShowNotificationsInDnd" /></label></td>
                <td width="100%">
                    <input class="cti_md cti_md_switch" type="checkbox" id="show_notifications_in_dnd"></input>
                </td>
            </tr>
            <tr>
                <td class="labels" nowrap="1" valign="top"><label for="user_settings_autoaway"><xsl:value-of select="/root/trans_texts/user.AutoAway" /></label></td>
                <td width="100%">
                    <input type="checkbox" id="user_settings_autoaway" class="cti_md cti_md_chbox"/>
                    <input type="number" id="user_settings_autoaway_delay" class="cti_md cti_md" min="1" max="99" size="2" maxlength="2"/> <span class="unit"><xsl:value-of select="/root/trans_texts/main.shortMinutes" /></span>
                </td>
            </tr>
            <xsl:if test="/root/modules/module_settings/@defstatus_settings_enabled='1'">
                <tr>
                    <td valign="top" class="labels" style="padding-top: 13px;" nowrap="1"><xsl:value-of select="/root/trans_texts/Status.QuickStatus" /></td>
                    <td valign="middle" style="padding: 10px;">
                        <div id="defstatus">
                            <div id="add-status">
                                <span class="status-icon">
                                    <span class="fa fa-stack status-available">
                                        <i class="fa fa-circle fa-stack-2x" style="color:#fff;"></i>
                                        <i class="fa fa-circle fa-stack-2x" style="color: #6fc465;"></i>
                                    </span>
                                </span>

                                <select name="status-type" class="cti_md">
                                    <option value="available"><xsl:value-of select="/root/trans_texts/Status.Online" /></option>
                                    <option value="away"><xsl:value-of select="/root/trans_texts/Status.Away" /></option>
                                    <option value="dnd"><xsl:value-of select="/root/trans_texts/Status.DoNotDisturb" /></option>
                                </select>
                                <input type="text" name="status-message" class="cti_md" />
                                <span class="status-time">
                                    <input type="checkbox" name="status-until-checkbox" class="cti_md cti_md_switch" checked="" />

                                    <input type="number" class="cti_md" min="0" max="24" value="0" name="status-hours"/>
                                     <label for="status-hours"><xsl:value-of select="/root/trans_texts/main.shortHours" /> </label>

                                    <input type="number" class="cti_md" min="0" max="60" value="15" name="status-min"/>
                                     <label for="status-min"><xsl:value-of select="/root/trans_texts/main.shortMinutes" /> </label>
                                </span>
                                <span class="status-add"><i rel="add" class="btn fa fa-plus"></i></span>
                            </div>
                            <div id="status-list">
                                <ul></ul>
                            </div>
                        </div>
                        <div class="clear"></div>

                    </td>
                </tr>
            </xsl:if>
            <tr>
                <td valign="top" class="labels" nowrap="1">
                    <div>
                        <button id="status-save" class="cti_md cti_md_bt inverse ui-button ui-corner-all ui-widget" type="button"><xsl:value-of select="/root/trans_texts/buttons.Save" /></button>
                    </div>
                </td>
                <td valign="middle" style="padding: 10px;"></td>
            </tr>
        </table>
    </xsl:template>

    <xsl:template match="/root/modules/module_settings/callgroups">
        <table border="0" width="650">
            <tr>
                <td class="labels" nowrap="1" valign="top">
                    <div  style="margin-top: 15px; margin-bottom: 0;">
                        <label for="contact_center_chkbx"><xsl:value-of select="/root/trans_texts/callcenter.enabled" /></label>
                    </div>
                </td>
                <td width="100%">
                    <div id="callcenter-mode" style="margin-top: 15px; margin-bottom: 0;">
                        <span></span>
                        <input type="checkbox" id="contact_center_chkbx" name="callcenter_mode" class="cti_md cti_md_switch"/>
                    </div>

                </td>
            </tr>

            <tr>
                <td class="labels" nowrap="1" valign="top">
                    <div  style="margin-top: 15px; margin-bottom: 15px;">
                        <label for="calls_chat_chkbx"><xsl:value-of select="/root/trans_texts/callcenter.calls_chat" /></label>
                </div>
                </td>
                <td width="100%">
                    <div id="calls_chat" style="margin-top: 15px; margin-bottom: 15px;">
                        <span></span>
                        <input type="checkbox" id="calls_chat_chkbx" name="calls_chat" class="cti_md cti_md_switch"/>
                    </div>

                </td>
            </tr>
            <tr>
                <td valign="top" class="labels" nowrap="1">
                    <xsl:value-of select="/root/trans_texts/callcenter.callgroups" />
                </td>
                <td valign="middle" style="padding: 10px;">
                    <div id="callgroups-list">
                        <ul class="group-list"></ul>
                    </div>
                </td>
            </tr>
            <tr>
                <td valign="top" class="labels" nowrap="1">
                </td>
                <td valign="middle" style="padding: 10px;">
                    <div>
                        <button id="callgroup-save" class="cti_md cti_md_bt inverse ui-button ui-corner-all ui-widget" type="button"><xsl:value-of select="/root/trans_texts/buttons.Save" /></button>
                    </div>
                </td>
            </tr>
        </table>
    </xsl:template>

</xsl:stylesheet>
