<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
    <xsl:output method="html"/>
    <xsl:template match="/root/modules/module_webrtc_zero_distance">
        <div id="module_webrtc_zero_distance">
            <video id="module_webrtc_zero_distance_remoteVideo" autoplay="autoplay"></video>
            <video id="module_webrtc_zero_distance_localVideo" autoplay="autoplay" muted="muted"></video>
        </div>
    </xsl:template>

    <xsl:template match="/root/modules/module_settings/webrtc_zero_distance">
        <table border="0" width="100%">
            <tr id="webrtc_zero_distance_settings_error">
                <td colspan="2" ><div class="ui-widget"><div class="ui-state-error ui-corner-all body"></div></div></td>
            </tr>
            <tr>
				<td class="labels" nowrap="1"><xsl:value-of select="/root/trans_texts/settings.device_play" /></td>
				<td><select id="webrtc_zero_distance_settings_device_audiooutput" name="device_audiooutput" class="cti_md"></select></td>
			</tr>
			<tr>
                <td class="labels" nowrap="1"><xsl:value-of select="/root/trans_texts/settings.device_ring" /></td>
                <td><select id="webrtc_zero_distance_settings_device_ringaudiooutput" name="device_ringaudiooutput" class="cti_md"></select></td>
            </tr>
            <tr>
                <td class="labels" nowrap="1"><xsl:value-of select="/root/trans_texts/settings.device_microphone" /></td>
                <td><select id="webrtc_zero_distance_settings_device_audioinput" name="device_audioinput" class="cti_md"></select></td>
            </tr>
            <tr>
                <td class="labels" nowrap="1"><xsl:value-of select="/root/trans_texts/settings.device_video" /></td>
                <td><select id="webrtc_zero_distance_settings_device_videoinput" name="device_videoinput" class="cti_md"></select></td>
            </tr>
            <tr>
                <td class="labels" nowrap="1">DSCP QoS</td>
                <td>
                    <div style="display: none" id="wms_tos"><xsl:value-of select='/root/modules/module_settings/@WMS_TOS' /></div>
                    <select id="webrtc_zero_distance_settings_DSCPQOS" name="device_DSCPQOS" class="cti_md">
                        <option value="default">Default</option>
                        <option value="on">On</option>
                        <option value="off">Off</option>
                    </select>
                </td>
            </tr>
            <tr>
                <td class="labels" nowrap="1"><xsl:value-of select="/root/trans_texts/settings.autogaincontrol" /></td>
                <td><input type="checkbox" id="webrtc_zero_distance_settings_autogaincontrol" name="autogaincontrol" class="cti_md cti_md_switch"></input></td>
            </tr>
            <tr>
                <td class="labels" nowrap="1"><xsl:value-of select="/root/trans_texts/settings.autostart" /></td>
                <td><input type="checkbox" id="webrtc_zero_distance_settings_autostart" name="autostart" class="cti_md cti_md_switch"></input></td>
            </tr>
            <tr>
                <td class="labels" nowrap="1"><xsl:value-of select="/root/trans_texts/settings.noiseSuppression" /></td>
                <td><input type="checkbox" id="webrtc_zero_distance_settings_noise_suppression" name="noiseSuppression" class="cti_md cti_md_switch"></input></td>
            </tr>
       </table>

        <div id="webrtc_zero_distance_devices_preview">

        </div>

        <div style="clear:both" />
        <div style="margin-top:30px;">
            <div align="left" class="buttonbox">
                <button id="user_settings_echo_webrtc_zero_distance" type="button" class="cti_md cti_md_bt inverse"><xsl:value-of select="/root/trans_texts/buttons.EchoTest" /></button>
            	<button id="user_settings_save_webrtc_zero_distance" type="button" class="cti_md cti_md_bt inverse"><xsl:value-of select="/root/trans_texts/buttons.Save" /></button>
            </div>
        </div>

    </xsl:template>
</xsl:stylesheet>
