export default class Route {

    constructor(data) {
        this.alias = data.alias;
        this.destination = data.destination;
        this.gateway = data.gateway;
        this.genmask = data.genmask;
        this.interface = data.interface;
        this.network = data.network;
        this.type = data.type;
    }

    get isDefaultGateway() {
        return this.destination === '0.0.0.0' && this.genmask === '0.0.0.0';
    }

    get isStatic() {
        return this.type === 'static';
    }

    get isEditable() {
        if (this.isDefaultGateway) {
            return this.isStatic;
        }
        return true;
    }

}
