import {FILE_SIZE} from '@/helpers/helpers';

export default class Sound {

    constructor(data) {
        this.name = data.name;
        this.path = data.path;
        this.size = this.prepareSize(data.size);
        this.modified = this.prepareModified(data.modified);
        this.isDir = data.isDir;
        this.isDefault = data.isDefault;
        this.formats = data.formats;
    }

    prepareSize(bytes) {
        return bytes === 0 ? '' : FILE_SIZE(bytes);
    }

    prepareModified(timestamp) {
        return timestamp === 0 ? '' : (new Date(timestamp * 1000)).toLocaleString('en-GB').slice(0, 17).replace(',', '');
    }

}
