import cloneDeep from '@/modules/clone-object';

export default class User {

    constructor(data) {
        this.department = data.department;
        this.dialplan = data.dialplan;
        this.dn = data.dn;
        this.email = data.email;
        this.extension = data.extension;
        this.faxDialplan = data.faxDialplan;
        this.faxNumber = data.faxNumber;
        this.groupDn = data.groupDn;
        this.groupName = data.groupName;
        this.id = data.id;
        this.jid = data.jid;
        this.language = data.language;
        this.licenseType = data.licenseType;
        this.login = data.login;
        this.mobilePhone = data.mobilePhone;
        this.name = data.name;
        this.officePhone = data.officePhone;
        this.pbxDn = data.pbxDn;
        this.picture = data.picture;
        this.role = data.role;
        this.pbx = data.pbx;
        this.sourceId = data.sourceId;
        this.registrations = [];
    }

    // @TODO This method is a forced measure.
    // The Colleague API currently expects certain fields, otherwise an error occurs.
    // After the WMS-14194 ticket, the Colleague API will accept any fields, but only use the required ones.
    prepareForSave() {
        const data = cloneDeep(this);

        delete data.groupName;
        delete data.registrations;
        delete data.jid;
        delete data.picture;
        delete data.sourceId;
        delete data.id;
        delete data.dn;
        delete data.pbx;

        return data;
    }

}
