import {makeRequest} from './helper';

function HotelGeneral(core){
    this.client = core.client;
}

Object.assign(HotelGeneral.prototype, {
    namespace: 'Hotel.General',

    getData() {
        return makeRequest(this.client._transport, {
            action: 'getGeneral'
        });
    },
    getStatus() {
        return makeRequest(this.client._transport, {
            action: 'getStatus'
        });
    },
    update: function(params) {
        return makeRequest(this.client._transport, {
            action: 'setGeneral',
            method: 'POST',
            data: params
        });
    },
    restart() {
        return makeRequest(this.client._transport, {
            action: 'reloadXml'
        });
    },
    clear() {
        return makeRequest(this.client._transport, {
            action: 'removeAllFile'
        });
    },
    removeConfig() {
        return makeRequest(this.client._transport, {
            action: 'removeHotelConfigurationFile',
            method: 'POST'
        });
    },
    generateConfig() {
        return makeRequest(this.client._transport, {
            action: 'generateHotelConfigurationFile',
            method: 'POST'
        });
    }
});

export default HotelGeneral;
