import {makeRequest} from './helper';

function HotelRooms(core){
    this.client = core.client;
}

Object.assign(HotelRooms.prototype, {
    namespace: 'Hotel.Rooms',

    getItems() {
        return makeRequest(this.client._transport, {
            action: 'getRooms',
            queryParams: {
                results: 1000
            }
        });
    },
    update(params) {
        return makeRequest(this.client._transport, {
            action: 'setRoom',
            method: 'POST',
            data: params
        });
    },
    uploadConfig(file) {
        const formData = new FormData();
        formData.append('XMLFile', file);
        const headers = {
            'Content-Type': 'multipart/form-data'
        };
        return makeRequest(this.client._transport, {
            method: 'POST',
            data: formData,
            queryParams: {
                uploadXML: 1
            },
            headers
        });
    }
});

export default HotelRooms;
