function workStations(core) {
    this.client = core.client;
}

Object.assign(workStations.prototype, {
    namespace: 'Hotel.workStations',

    getItems: function() {
        return this.client._transport('/hotel_integration/action.php?action=getWorkstations&results=10000');
    },
    add: function(params) {
        return this.client._transport(`/hotel_integration/action.php?action=setWorkstation`,
            {
                method: 'POST',
                data: params
            }
        );
    },
    update: function(params) {
        const formData = new FormData();
        formData.set('action', 'setWorkstation');
        formData.set('data', JSON.stringify(params));
        return this.client._transport(`/hotel_integration/action.php`,
            {
                method: 'POST',
                headers: {
                    'Content-Type': 'application/x-www-form-urlencoded; charset=UTF-8'
                },
                data: formData
            }
        );
    },
    remove: function(params) {
        const formData = new FormData();
        formData.set('action', 'delWorkstation');
        formData.set('data', JSON.stringify(params));
        return this.client._transport(`/hotel_integration/action.php`,
            {
                method: 'POST',
                data: formData,
                headers: {
                    'Content-Type': 'application/x-www-form-urlencoded; charset=UTF-8'
                }
            }
        );
    },
    clear: function() {
        return this.client._transport(`/hotel_integration/action.php?action=removeWorkstationsMappingFile`,
            {
                method: 'POST'
            }
        );
    }
});

export default workStations;
