function Backups(core){
    this.client = core.client;
}

const path = '/v1/pbx/settings/backups/';
const soundPath = '/v1/pbx/settings/soundbackups/';
const checkPath = '/v1/pbx/settings/backups/status';

Object.assign(Backups.prototype, {
    namespace: 'PBX.Settings.Backups',
    get(){
        return this.client.send('GET', path);
    },
    create(file) {
        const formData = new FormData();
        const headers = {};

        if (file) {
            formData.append('file', file);
            headers['Content-Type'] = 'multipart/form-data';
        }
        return this.client.send('POST', path, formData, headers);
    },
    downloadSound() {
        return this.client._transport(
            '/api' + soundPath,
            {
                responseType: 'blob',
                method: 'POST',
                validateStatus: function (status) {
                    return status === 200;
                }
            }
        );
    },
    apply(name, restoreNetwork) {
        return this.client.send('PUT', path + name, {
            network: restoreNetwork
        });
    },
    delete(name) {
        return this.client.send('DELETE', path + name);
    },
    download(name) {
        return this.client._transport(
            '/api' + path + name,
            {
                responseType: 'blob',
                method: 'GET',
                validateStatus: function (status) {
                    return status === 200;
                }
            }
        );
    },
    checkStatus() {
        return this.client.send('GET', checkPath, {
            loader: false
        });
    }
});

export default Backups;
