function Phonebooks(core){
    this.client = core.client;
}

const phonebookPath = '/v1/phonebooks/';

Object.assign(Phonebooks.prototype, {
    namespace: 'Phonebooks',

    get(params) {
        return this.client.send('GET', phonebookPath, params);
    },
    create(params) {
        return this.client.send('POST', phonebookPath, params);
    },
    update(id, params) {
        return this.client.send('PUT', `${phonebookPath}/${id}/`, params);
    },
    remove(id) {
        return this.client.send('DELETE', `${phonebookPath}/${id}/`);
    },
    clear(id) {
        return this.client.send('DELETE', `${phonebookPath}/${id}/contacts`);
    }
});

export default Phonebooks;
