function Sounds(core){
    this.client = core.client;
}

const path = '/v1/sounds/';
const directoryPath = `${path}directory/`;

Object.assign(Sounds.prototype, {
    namespace: 'Sounds',
    get(params) {
        return this.client.send('GET', `${path}${params}`);
    },
    create(params) {
        return this.client.send('POST', path, params);
    },
    update(filePath, params) {
        return this.client.send('PUT', `${path}${filePath}`, params);
    },
    delete(filePath) {
        return this.client.send('DELETE', `${path}${filePath}`);
    },
    createDirectory(params) {
        return this.client.send('POST', directoryPath, params);
    },
    updateDirectory(path, params) {
        return this.client.send('PUT', `${directoryPath}${path}`, params);
    },
    deleteDirectory(path) {
        return this.client.send('DELETE', `${directoryPath}${path}`);
    },
    check(params) {
        return this.client.send('GET', `${path}check/${params}`);
    },
    upload(params) {
        const formData = new FormData();
        formData.append('file', params.file);
        formData.append('directory', params.directory);

        return this.client.send('POST', path, formData);
    }
});

export default Sounds;
