function Tts(core){
    this.client = core.client;
}

const host = window.env.serviceTextToSpeechUri;

const getAuthorizationService = () => {
    return new ServiceJwtAuthorization('Tts', new URL(host).host.split('.')[0]);
};

Object.assign(Tts.prototype, {
    namespace: 'Tts',

    getSettings(params = {}) {
        return getAuthorizationService()
            .authorizeRequest(accessToken => {
                if (!accessToken) {
                    return Promise.reject({status: 401});
                }

                return jQuery.ajax({
                    type: 'GET',
                    remoteService: true,
                    cache: false,
                    crossDomain: true,
                    xhrFields: {
                        withCredentials: false
                    },
                    headers: {
                        Authorization: 'Bearer ' + accessToken
                    },
                    data: params,
                    url: host + '/api/v2/Settings/',
                    dataType: 'JSON'
                });
            }, 2);
    },
    getAudio(params = {}) {
        return this.client._transport({
            method: 'GET',
            url: `${host}/Audio/`,
            params,
            withCredentials: false,
            mode: 'cors',
            responseType: 'arraybuffer',
            headers: {
                Authorization: 'Bearer ' + getAuthorizationService().getAccessToken(),
                Accept: 'audio/*'
            },
            validateStatus: status => status >= 200 && status <= 202
        })
            .then(response => response.data)
            .catch(error => Promise.reject(error.response));
    }
});

export default Tts;
