function Users(core){
    this.client = core.client;
}

const colleaguesPath = '/v1/PBX/Colleagues/';
const registrationsPath = '/v1/PBX/Users/';

Object.assign(Users.prototype, {
    namespace: 'Users',

    get(params) {
        return this.client.send('GET', colleaguesPath, params);
    },
    create(params) {
        return this.client.send('POST', colleaguesPath, params);
    },
    update(id, params) {
        return this.client.send('PUT', `${colleaguesPath}/${id}/`, params);
    },
    remove(id, params) {
        return this.client.send('DELETE', `${colleaguesPath}/${id}/${params}`, {
            loader: false
        });
    },
    editPreferences(id, params) {
        return this.client.send('PUT', `${colleaguesPath}/${id}/preferences/`, {
            loader: false,
            ...params
        });
    },
    getRegistrations(users, loader) {
        return this.client.send('GET', `${registrationsPath}${users.join(',')}/Sip/Registrations/`, {loader});
    }
});

export default Users;
