import errorsMixin from '@/modules/errors-mixin';
import dirtyMixin from '@/modules/dirty-mixin';

export default {
    name: 'baseModal',
    mixins: [errorsMixin, dirtyMixin],
    props: {
        callback: {
            type: Function,
            default: () => {}
        }
    },
    data() {
        return {
            callbackParams: {}
        };
    },
    destroyed() {
        this.callback(this.callbackParams);
    },
    methods: {
        close(state = false) {
            this.$modal.close(state || !this.isDirty());
        },
        disableNativeClose(value = true) {
            this.$modal.disableNativeClose(value);
        }
    }
};
