import Modal from './wrapper.vue';
import {MODAL_SHOW, MODAL_HIDE, MODAL_TITLE, MODAL_LOADER, MODAL_DISABLE_NATIVE_CLOSE} from '@/configuration/constants';

Modal.install = function (Vue) {
    Vue.component(Modal.name, Modal);
    Vue.prototype.$modal = new Vue({
        name: '$modal',
        methods: {
            open(options) {
                this.$modal.$emit(MODAL_SHOW, options);
            },
            close(dontAnswer = true) {
                this.$modal.$emit(MODAL_HIDE, {dontAnswer: dontAnswer});
            },
            disableNativeClose(value) {
                this.$modal.$emit(MODAL_DISABLE_NATIVE_CLOSE, value);
            },
            setTitle(title = '') {
                this.$modal.$emit(MODAL_TITLE, {title: title});
            },
            loader(state = false) {
                this.$modal.$emit(MODAL_LOADER, {state: Boolean(state)});
            }
        }
    });
};

export default Modal;
