import translate from '@/modules/translate/translate';

export const TABLE_COLS = [
    {
        key: 'wcgrp',
        label: translate('aclpbx.wcgrp'),
        sortable: true,
        thStyle: {
            width: '50px'
        }
    },
    {
        key: 'name',
        label: translate('aclpbx.Group'),
        sortable: true
    },
    {
        key: 'inherits.name',
        label: translate('aclpbx.InheritsFrom'),
        sortable: true,
        thStyle: {
            width: '200px'
        },
        filterByFormatted: true,
        formatter: (value, key, item) => item.inherits.name
    }
];

export const CAN_OPTIONS = {
    'yes': translate('strings.can'),
    'no': translate('strings.canNot'),
    'set': translate('strings.canSet'),
    'noset': translate('strings.canNotSet'),
    'use': translate('strings.canUse'),
    'nouse': translate('strings.canNotUse'),
    'call': translate('strings.canCall'),
    'nocall': translate('strings.canNotCall')
};

export const EMPTY_INHERIT = {value: null, text: '---'};

export const EMPTY_GROUP = {value: 'all', text: translate('acl.allgroups')};

export const NEW_ACL = {rule: 'CALL', ability: 'no', group: 'all'};

export const PERMISSION_OPERATIONS = {
    'epbx': translate('acl.canManagePbx'),
    'noepbx': translate('acl.canNotManagePbx'),
    'egroup': translate('acl.canManageGroup'),
    'noegroup': translate('acl.canNotManageGroup'),
    'epage': translate('acl.canViewPage'),
    'noepage': translate('acl.canNotViewPage'),
    'eperm': translate('strings.can'),
    'noeperm': translate('strings.canNot')
};

export const NEW_ADMIN_ACL = {operation: 'epage', subject: 'all'};
