import translate from '@/modules/translate/translate';
import store from '@/store/index';

export const PREMIUM = 'premium';
export const BUSINESS = 'business';
export const ESSENTIAL = 'essential';
export const BASIC = 'basic';

const PBX_BASIC = 'PBX-Basic';
const UC_ESSENTIAL = 'UC-Essential';
const UC_BUSINESS = 'UC-Business';
const UC_PREMIUM = 'UC-Premium';

const X_BEES_DEVICE = 'x-bees-Device';
const X_BEES_BASIC = 'x-bees-Basic';
const X_BEES_STANDARD = 'x-bees-Standard';
const X_BEES_SUPER_BEE = 'x-bees-SuperBee';

const X_HOPPERS_DEVICE = 'x-hoppers-Device';
const X_HOPPERS_BACK_OFFICE = 'x-hoppers-BackOffice';
const X_HOPPERS_SALES_FLOOR_HOPPER = 'x-hoppers-SalesFloorHopper';
const X_HOPPERS_SUPER_HOPPER = 'x-hoppers-SuperHopper';

export const getLicenseLabel = (license) => {
    const licenses = {
        pbxService: translate('license.type.pbxService'),
        wizyconf: translate('license.type.wizyconf'),
        basic: PBX_BASIC,
        essential: UC_ESSENTIAL,
        business: UC_BUSINESS,
        premium: UC_PREMIUM
    };

    if (store.getters.isXHoppersLicenseType()) {
        const xHoppersLicenses = {
            ...licenses,
            basic: X_HOPPERS_DEVICE,
            essential: X_HOPPERS_BACK_OFFICE,
            business: X_HOPPERS_SALES_FLOOR_HOPPER,
            premium: X_HOPPERS_SUPER_HOPPER
        };

        return xHoppersLicenses[license] || '';
    }

    if (store.getters.isXBeesLicenseType()) {
        const xBeesLicenses = {
            ...licenses,
            basic: X_BEES_DEVICE,
            essential: X_BEES_BASIC,
            business: X_BEES_STANDARD,
            premium: X_BEES_SUPER_BEE
        };

        return xBeesLicenses[license] || '';
    }

    return licenses[license] || '';
};

export const BOOL_LICENSE_USAGE = [
    'x-caracal',
    'wizyWebinar',
    'classound',
    'msphonesystem',
    'networkLicense'
];

export const QUANTITY_LICENSE_USAGE = [
    {value: 'basic', text: getLicenseLabel('basic')},
    {value: 'essential', text: getLicenseLabel('essential')},
    {value: 'business', text: getLicenseLabel('business')},
    {value: 'premium', text: getLicenseLabel('premium')},
    {value: 'wizyconf', text: getLicenseLabel('wizyconf')},
    {value: 'pbxService', text: getLicenseLabel('pbxService')}
];
