import translate from '@/modules/translate/translate';
import LinkStatusCell from '@/pages/network/_chunks/NetworkInterfaces/_chunks/LinkStatusCell.vue';

export const TABLE_COLS_NETWORK_INTERFACES = [
    {
        key: 'description',
        label: translate('net.Interface'),
        sortable: true
    },
    {
        key: 'kind',
        label: translate('net.Type'),
        sortable: true
    },
    {
        key: 'interfaceAddr',
        label: translate('net.Address'),
        sortable: true
    },
    {
        key: 'interfaceNetmask',
        label: translate('net.Netmask'),
        sortable: true
    },
    {
        key: 'activate',
        label: translate('net.LinkState'),
        renderComponent: () => (LinkStatusCell),
        thClass: 'link-state'
    }
];

export const TABLE_COLS_ROUTING = [
    {
        key: 'interface',
        label: translate('net.Interface'),
        sortable: true
    },
    {
        key: 'destination',
        label: translate('net.Destination'),
        sortable: true
    },
    {
        key: 'genmask',
        label: translate('net.Netmask'),
        sortable: true
    },
    {
        key: 'gateway',
        label: translate('net.Gateway'),
        sortable: true
    }
];

export const TABLE_COLS_HOSTS = [
    {
        key: 'address',
        label: translate('net.Address'),
        sortable: true
    },
    {
        key: 'hostname',
        label: translate('net.Host'),
        sortable: true
    }
];
