import translate from '@/modules/translate/translate';
import {HostCell, VersionCell, FailoverCell} from '@/pages/users/pbxesTab/_chunks/tableCells';

export const TABLE_COLS = [
    {
        key: 'ip',
        label: translate('multipbx.ip_address'),
        sortable: true,
        resizeable: true,
        tdClass: 'namestyle150'
    },
    {
        key: 'serial',
        label: translate('multipbx.serial'),
        sortable: true,
        resizeable: true,
        tdClass: 'namestyle150'
    },
    {
        key: 'host',
        label: translate('multipbx.domain'),
        sortable: true,
        resizeable: true,
        tdClass: 'namestyle150',
        renderComponent: () => (HostCell)
    },
    {
        key: 'failOver',
        label: translate('multipbx.failover'),
        sortable: true,
        resizeable: true,
        tdClass: 'namestyle150',
        renderComponent: () => (FailoverCell)
    },
    {
        key: 'version',
        label: translate('multipbx.wmsVersion'),
        sortable: true,
        resizeable: true,
        tdClass: 'namestyle150',
        renderComponent: () => (VersionCell)
    }
];

export const getRedirectLink = function (item) {
    let url;
    if(item.host.include('.wildixin.com')) {
        url = `https://${item.host}/`;
    } else {
        url = `https://${item.serial}.wildixin.com/`;
    }
    return url;
};
