import translate from '@/modules/translate/translate';
import {CountryCodeCell} from '@/pages/trunks/trunkLists/_chunks/tableCells';
import {StatusCell} from '@/pages/trunks/trunkLists/pstn/fxo/_chunks/tableCells';

export const DEVICE_MODELS_FXO_DINSTAR = ['w04fxor3', 'w04fxor4'];

export const MAIN_TABLE_COLS = [
    {
        key: 'id',
        label: translate('strings.ID'),
        sortable: true,
        thStyle: {
            width: '35px'
        }
    },
    {
        key: 'title',
        label: 'FXO',
        sortable: true
    },
    {
        key: 'settingsMgw.ports[0].context',
        label: `${translate('trunks.Port')} 1 ${translate('trunks.Context')}`,
        thStyle: {
            width: '65px',
            maxWidth: '65px'
        },
        tdClass: 'text-center trunk-port-cell',
        tdAttr: value => ({title: value})
    },
    {
        key: 'settingsMgw.ports[1].context',
        label: `${translate('trunks.Port')} 2 ${translate('trunks.Context')}`,
        thStyle: {
            width: '65px',
            maxWidth: '65px'
        },
        tdClass: 'text-center trunk-port-cell',
        tdAttr: value => ({title: value})
    },
    {
        key: 'settingsMgw.ports[2].context',
        label: `${translate('trunks.Port')} 3 ${translate('trunks.Context')}`,
        thStyle: {
            width: '65px',
            maxWidth: '65px'
        },
        tdClass: 'text-center trunk-port-cell',
        tdAttr: value => ({title: value})
    },
    {
        key: 'settingsMgw.ports[3].context',
        label: `${translate('trunks.Port')} 4 ${translate('trunks.Context')}`,
        thStyle: {
            width: '65px',
            maxWidth: '65px'
        },
        tdClass: 'text-center trunk-port-cell',
        tdAttr: value => ({title: value})
    },
    {
        key: 'address',
        label: translate('strings.Host'),
        sortable: true,
        thStyle: {
            width: '105px'
        },
        tdClass: 'text-center trunk-port-cell'
    },
    {
        key: 'settingsMgw.countryCode',
        label: translate('prefs.GCOUNTRY_CODE'),
        sortable: true,
        thStyle: {
            width: '50px'
        },
        renderComponent: () => (CountryCodeCell)
    },
    {
        key: 'status',
        label: translate('trunks.Status'),
        thStyle: {
            width: '55px'
        },
        renderComponent: () => (StatusCell)
    }
];

export const TRUNK_ITEM_MAIN_FIELDS_ERRORS = {
    settingsMgw: {
        countryCode: null,
        currentDisconnectThreshold: null,
        silenceDetection: null,
        ports: []
    }
};

export const TRUNK_ITEM_PORT_FIELDS_ERRORS = {
    destinationCode: null,
    hotlineNumber: null,
    flashTime: null,
    answerTime: null
};

export const IMPEDANCE_LIST = [
    {value: 1, text: '270R+750R//150nF (Italy/Sweden)'},
    {value: 2, text: '220R+820R//115nF (Germany)'},
    {value: 3, text: '370R+620R//310nF (UK)'},
    {value: 4, text: '180R+910R//150nF (France)'},
    {value: 5, text: '120R+820R//110nF (Norway)'},
    {value: 6, text: '150R+830R//72nF (Belgium)'},
    {value: 7, text: '400R+500R//330nF (Denmark)'},
    {value: 8, text: '600R'},
    {value: 9, text: '900R'},
    {value: 10, text: '320R+230nF'},
    {value: 11, text: '370R+110nF'},
    {value: 12, text: '275R+115nF'},
    {value: 13, text: '350R+210nF'},
    {value: 14, text: '200R+100nF'},
    {value: 15, text: '600R+2.16μF'},
    {value: 16, text: '900R+1μF'},
    {value: 17, text: '900R+2.16μF'},
    {value: 18, text: '600R+1μF'},
    {value: 19, text: 'Global'}
];

export const CID_TYPES = [
    {value: -1, text: 'None'},
    {value: 0, text: 'Bellcore FSK'},
    {value: 1, text: 'ETSI FSK'},
    {value: 3, text: 'ETSI DTMF'}
];

export const FAX_TYPES = [
    {value: 1, text: 'Bypass'},
    {value: 2, text: 'T38'}
];

export const FAX_SPEEDS = [
    {value: 2400, text: '2400'},
    {value: 4800, text: '4800'},
    {value: 7200, text: '7200'},
    {value: 9600, text: '9600'},
    {value: 12000, text: '12000'},
    {value: 14400, text: '14400'}
];

export const FSK_CID_FIELDS = [
    {value: 0, text: 'Num'},
    {value: 1, text: 'Callee'}
];
