function Acl(routes, configs) {
    const config = {};
    routes.forEach(function (item){
        config[item.path] = {
            path: item.path,
            meta: item.meta,
            disabled: item.meta?.disableOnNotActive && (!configs.license?.activated || configs.user?.isDefaultPassword),
            hidden: item.meta?.hidden ?? false,
            denied: Boolean(item.meta?.resource && !configs['acl'][item.meta.resource])

        };
    });
    this.config = config;
}

Acl.prototype.recalculate = function(configs) {
    for (let configKey in this.config) {
        const item = this.config[configKey];
        item.disabled = item.meta?.disableOnNotActive && (!configs.license?.activated || configs.user?.isDefaultPassword);
        item.denied = Boolean(item.meta?.resource && !configs['acl'][item.meta.resource]);
    }
};

Acl.prototype.has = function(path) {
    if (this.config.hasOwnProperty(path)) {
        return this.config[path].denied !== true && this.config[path].hidden !== true && this.config[path].disabled !== true;
    }

    return false;
};

export default Acl;
