import RestApi from '@/api';
import store from '@/store';

let ApiPlugin = {};

const Api = new RestApi();
Api.client.events.onRequestStart = function(url, method, data, params) {
    if(params.loader !== false) {
        store.commit('showLoader');
    }
};
Api.client.events.onRequestSuccess = function({config}) {
    if(config.params.loader !== false) {
        store.commit('hideLoader');
    }
};
Api.client.events.onRequestError = function({config}) {
    if(config.params.loader !== false) {
        store.commit('hideLoader');
    }
};

ApiPlugin.install = function (Vue, options) {
    Vue.prototype.$api = Api;
};

export default ApiPlugin;
