export default {
    data() {
        return {
            progress: {
                value: 0,
                max: 0,
                show: false,
                process: false
            }
        };
    },
    methods: {
        runProgressBar() {
            this.progress.value = 0;

            this.progress.process = true;

            if (this.items.length > 1) {
                this.progress.show = true;
            }
        },
        setProgressBarMaxValue(value) {
            this.progress.max = value;
        },
        setProgressBarValue(value) {
            this.progress.value = value;
        },
        incrementProgressBarValue() {
            this.progress.value++;
        },
        isProgressBarDone() {
            return this.progress.max === this.progress.value;
        },
        isProgressBarRunning() {
            return this.progress.process && (this.progress.value !== this.progress.max);
        }
    }
};
