export default {
    data() {
        return {
            alertErrors: []
        };
    },
    methods: {
        showAlertErrors(error, userExtension) {
            if (error.data && error.data.reason) {
                const extension = `${this.$t('aclpbx.extenNumber')}: ${userExtension}`;
                const reason = `${this.$t('state.Fail.Reason')} ${error.data.reason}`;
                this.alertErrors.push(`${extension} <br> ${reason}`);
            }
        },
        clearAlertErrors() {
            this.alertErrors = [];
        },
        clearAllErrors() {
            this.clearAlertErrors();
            this.clearErrors();
        },
        hasAlertErrors() {
            return this.alertErrors.length > 0;
        },
        hasErrors() {
            const result = Object.keys(this.fieldErrors).find(item => this.fieldErrors[item] !== null);
            return Boolean(result);
        },
        showError(error, userExtension) {
            if (error.data && error.data.errors && Object.keys(error.data.errors).length) {
                this.showErrors(error);
            } else {
                this.showAlertErrors(error, userExtension);
            }
        }
    }
};
