import Vue from 'vue';
import VueRouter from 'vue-router';
import {getRoutes} from './routes';
import store from '@/store';
import {middlewarePipeline} from './middleware';
const routes = getRoutes(store.getters.isCloud(), store.getters.isSlave());

store.dispatch('initAcl', routes);
// for enable Vue-Devtools execute this in browser console
// localStorage.vueDevTools = true
Vue.config.devtools = (localStorage.vueDevTools === 'true' || !(process.env.NODE_ENV === 'production'));

if(!window.translation) {
    window.translation = {};
}

Vue.use(VueRouter);

const index = new VueRouter({
    linkActiveClass: 'active',
    scrollBehavior(to, from, savedPosition) {
        return {x: 0, y: 0};
    },
    history: true,
    routes
});

index.beforeEach((to, from, next) => {
    if(!to.meta.middleware) {
        return next();
    }
    const middleware = to.meta.middleware;
    const context = {to, from, next, store};
    return middleware[0]({...context, next: middlewarePipeline(context, middleware, 1)});
});

export default index;
