export const verifyAccess = function({to, next, store}) {
    if(to.meta?.resource && !store.getters.aclCore().has(to.path)) {
        return next({
            name: 'permissionsDenied',
            params: [to.path],
            replace: true
        });
    }

    return next();
};

export const middlewarePipeline = function (context, middleware, index) {
    const nextMiddleware = middleware[index];
    if(!nextMiddleware) {
        return context.next;
    }
    return () => {
        const nextPipeline = middlewarePipeline(context, middleware, index + 1);
        nextMiddleware({...context, next: nextPipeline});
    };
};
