const jquery=require("jquery");class RetryError extends Error{constructor(message,statusCode=400){super(message);this.status=statusCode;this.statusText=message}}const toDebug=function(){if(window.env.debug){console.warn("[auth_service]",...arguments)}};class AuthCache{constructor(){this.cacheStore={};this.lockStore={}}getCacheKey(aud,scope=""){return`${aud}_${scope.replaceAll(" ","_")}`}get(key){return this.cacheStore[key]}set(key,data){this.cacheStore[key]=data;return data}delete(key){delete this.cacheStore[key];toDebug(`delete cache for ${key}`)}lock(key,second=10){const data=this.lockStore[key];if(data&&data>Date.now()){return false}this.lockStore[key]=Date.now()+second*1e3;toDebug("SET_LOCK",key);return true}release(key){if(this.lockStore[key]){delete this.lockStore[key];toDebug("RELEASE_LOCK",key)}return true}clear(){this.cacheStore={};this.lockStore={};toDebug("clear cache")}}class AuthUtils{unpackJwtToken(token){try{const parts=token.split(".");if(parts.length!==3){throw new Error("Incorrect token parts")}return{head:JSON.parse(atob(parts[0])),payload:JSON.parse(atob(parts[1]))}}catch(e){console.error(e.message,token);return false}}isAliveJwtToken(token){const tokenData=this.unpackJwtToken(token);const time=Math.round(Date.now()/1e3);return tokenData&&tokenData.payload.iat<time&&tokenData.payload.exp>time}}class AuthService{constructor(authServiceUri){this.authServiceUri=authServiceUri;this.cache=new AuthCache;this.utils=new AuthUtils;this._fetchPersonalToken=(tryCount=1)=>jquery.ajax({url:"/api/v1/personal/token/",type:"GET",cache:false,crossDomain:true,data:{service:new URL(this.authServiceUri).host},dataType:"json",timeout:5*1e3}).then((result=>result.result.token)).catch((err=>{if(err&&err.statusText==="timeout"&&tryCount>1){return this._fetchPersonalToken(tryCount-1)}throw err}));this._fetchAuthTokens=(personalToken,tryCount=1)=>jquery.ajax({url:this.authServiceUri+"/api/v2/Token/",type:"GET",remoteService:true,cache:false,dataType:"json",crossDomain:true,headers:{Authorization:"Bearer "+personalToken},timeout:10*1e3}).then((({result:result})=>result)).catch((err=>{if(err&&err.statusText==="timeout"&&tryCount>1){return this._fetchAuthTokens(personalToken,tryCount-1)}throw err}));this._fetchJwtTokenForService=(serviceName,authAccessToken,tryCount=1)=>jquery.ajax({url:`${this.authServiceUri}/api/v2/Token/${serviceName}/`,type:"GET",remoteService:true,cache:false,dataType:"json",crossDomain:true,headers:{Authorization:"Bearer "+authAccessToken},timeout:10*1e3}).then((({result:result})=>result.token)).catch((err=>{if(err&&err.statusText==="timeout"&&tryCount>1){return this._fetchJwtTokenForService(serviceName,authAccessToken,tryCount-1)}throw err}));this._fetchOpenIdToken=(authAccessToken,payload,tryCount=1)=>jquery.ajax({url:this.authServiceUri+"/api/v2/OpenId/service/",type:"POST",remoteService:true,cache:false,dataType:"json",data:payload,crossDomain:true,headers:{Authorization:"Bearer "+authAccessToken},timeout:10*1e3}).then((result=>result.result.id_token)).catch((err=>{if(err&&err.statusText==="timeout"&&tryCount>1){return this._fetchOpenIdToken(authAccessToken,payload,tryCount-1)}throw err}));this._openIdAuthFlow=async(aud,scope)=>{const cacheKey=this.getCache().getCacheKey(aud,scope);const cachedToken=this.getCache().get(cacheKey);if(cachedToken&&this.getUtils().isAliveJwtToken(cachedToken)){return cachedToken}const lockStatus=this.getCache().lock(this.authServiceUri);toDebug({lockStatus:lockStatus});if(!lockStatus){throw new Error(`Can't set lock for ${cacheKey}`)}toDebug("START_FULL_AUTH_FLOW",cacheKey);let authTokens=this.getCache().get(this.authServiceUri);if(!authTokens||!authTokens.accessToken||!this.getUtils().isAliveJwtToken(authTokens.accessToken)){toDebug("FETCH_TOKENS_FOR_AUTH");authTokens=await this.fetchAuthServiceTokens();this.getCache().set(this.authServiceUri,authTokens)}const openIdToken=await this._fetchOpenIdToken(authTokens.accessToken,{aud:aud,scope:scope});this.getCache().set(cacheKey,openIdToken);this.getCache().release(this.authServiceUri);toDebug("END_FULL_AUTH_FLOW");return openIdToken}}getCache(){return this.cache}getUtils(){return this.utils}fetchAuthServiceTokens(){return this._fetchPersonalToken().then((personalToken=>this._fetchAuthTokens(personalToken)))}fetchJwtTokenForService(serviceName){return this.fetchAuthServiceTokens().then((({accessToken:accessToken})=>this._fetchJwtTokenForService(serviceName,accessToken)))}async fetchOpenIdTokenForServiceWithRetries(aud,scope,retry=5,delay=1e3){toDebug("GET_OPENID_TOKEN_FOR_SERVICE",{aud:aud,scope:scope,retry:retry,delay:delay});return new Promise(((resolve,reject)=>{this._openIdAuthFlow(aud,scope).then(resolve).catch((error=>{console.warn("[auth_service] fetchOpenIdTokenForService error",error.message);if(error.status===401){this.getCache().delete(this.authServiceUri)}if(error.status===403){reject(new Error("Permission denied"))}if(retry>0){retry--;setTimeout((()=>{this.fetchOpenIdTokenForServiceWithRetries(aud,scope,retry,delay*2).then(resolve).catch(reject)}),delay)}else{reject(new RetryError(`Failed to make request after retries`))}}))}))}}let authInstance;module.exports=function getAuthService(){if(!authInstance){authInstance=new AuthService(window.env.serviceAuthUri);window.AuthService=authInstance}return authInstance};